
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// "BUG" FIREFOX -> https://bugzilla.mozilla.org/show_bug.cgi?id=548397
if (/firefox/i.test(navigator.userAgent)){
   window.oldGetComputedStyle = window.getComputedStyle;
   window.getComputedStyle = function (element, pseudoElt) {
      var t = window.oldGetComputedStyle(element, pseudoElt);
      if (t === null) {
         return {
            getPropertyValue: function(){}
         };
      } else{
         return t;
      }
   };
}

require.config({
    path:{
        'orion/editor/nls/messages': '../orion/editor/nls/messages'
    },
    config: { 
        'orion/editor/nls/messages': {root: true, 'fr': true},
        'orion/edit/nls/messages': {root: true, 'fr': true}
    }
});

function getParameterByName(name, url) {
    if (!url) {
      url = window.location.href;
    }
    name = name.replace(/[\[\]]/g, "\\$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, " "));
}


var _rppDebug =  getParameterByName('rppDebug');
var _rppMin = "";
if ( _rppDebug != "true" )
	_rppMin = ".min";

require(["code_edit/built-codeEdit-amd"+_rppMin], function() {
			    require([
    					"orion/codeEdit", 'orion/editor/rulers', 'orion/editor/textStyler',
    					"../internal/page/jsModules/cobol/styleParser",
    					"../internal/page/jsModules/cobol/cobolStyler",
    					"../internal/page/jsModules/cobol/textStyler",
    					"cobol/sequenceNumberRuler",
    					"../internal/page/jsModules/cobol/util",
    					"i18n!rpp/nls/message"
    					], function(mCodeEdit, Ruler, orionTextStyler, mStyleParser, mCobolStyler, mTextStyler, mSequenceNumberRuler, mEditUtil, rppMessage) {
    				
    				var _streamId = getParameterByName('streamId');
    				var _fileItemId = getParameterByName('fileItemId');
    				var _type = getParameterByName('type');
    				var _project = getParameterByName('project');
    				var _compentId = getParameterByName('compentId');
    				var _generated = getParameterByName('generated');
    				var _sequenceNumber = getParameterByName('sequenceNumber');
    				var _size = getParameterByName('size');
    				
    				if ( _sequenceNumber == undefined )
    					_sequenceNumber = false;
    				
    				if ( _size == undefined )
    					_size = '490px';
        			
        			var http = new XMLHttpRequest();
        			
        			var url;
        			var params;
        			
        			if ( _generated == "true") {
        				url = "../../../../service/com.ibm.teampdp.query.engine.common.IRppGeneratedFileService";			
        				params = "streamId="+_streamId+"&fileItemId="+_fileItemId+"&type="+_type+"&project="+_project+"&compentId="+_compentId
        			} else {
        				url = "../../../../service/com.ibm.teampdp.query.engine.common.IRppDesignFileService";			
        				params = "sourceCode=true&streamId="+_streamId+"&fileItemId="+_fileItemId+"&type="+_type+"&project="+_project+"&compentId="+_compentId;
        			}
        		
        			document.getElementById('embeddedEditor').style.height = _size;
        			
        			document.getElementById('embeddedEditor').innerHTML = "<p align='center'><b>"+rppMessage.Loading+"</b></p>";
        			
					http.open("POST", url, true);

					//Send the proper header information along with the request
					http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

					http.onreadystatechange = function() {//Call a function when the state changes.
    					if(http.readyState == 4 && http.status == 200) {
        					var codeEdit = new mCodeEdit();
            				if ( _type == 'cbl' || _type == 'cpy' || _type == 'pacmacro' ) {
            					var cto = {
            							id: "text/cobol",
            							extension: ["cbl"],
            							name: "COBOL",
            							'extends': 'text/plain'
            					};
                			

            					codeEdit.serviceRegistry.registerService('orion.core.contenttype', {}, {contentTypes: [cto]});
                			
            					var contents = null;
            					var intro = null;
            					
            					if ( _sequenceNumber ) {
            						var sequenceNumbers = [{start: 0, end: 6}, {start: 72, end: 80}];
            						var lineLength = 80;
    						
            						var contentModel = mEditUtil.removeSequenceNumbers(
            								sequenceNumbers, 
            								lineLength, 
            								http.responseText, "\n");
            						
            						contents = contentModel.mainContent; 
            					} else {            						
            						contents = http.responseText;
            						var lines = mEditUtil.splitInTwoFiles(contents);
            						contents = lines[0];          						
            						intro = lines[1];            						
            					}            					
                
            					var defaultPluginURLs = [];
        					
            					codeEdit.create({_defaultPlugins: defaultPluginURLs, parent: "embeddedEditor", contentType: "text/cobol", contents: contents}).then(function(editorViewer) {
        						
        						editorViewer.readonly = true;
        		
        						var editor = editorViewer.editor;
        		
        						if (editorViewer.settings) {
        							editorViewer.settings.contentAssistAutoTrigger = false;
        							editorViewer.settings.showOccurrences = true;
        							editorViewer.settings.showMargin = true;
        						}
        						
        						
        						if ( _sequenceNumber ) {
        							var leftSequenceNumberRuler =
        								new mSequenceNumberRuler.SequenceNumberRuler(editor.getAnnotationModel(), 
        										"left", {styleClass: "sequenceNumberRuler left"},
        										contentModel.leftSequenceNumbers, 
        										sequenceNumbers[0]
        									);
        							editor.getTextView().addRuler(leftSequenceNumberRuler);
        						
        							var rightSequenceNumberRuler =
        								new mSequenceNumberRuler.SequenceNumberRuler(editor.getAnnotationModel(), 
        										"margin", {styleClass: "sequenceNumberRuler right"},
        										contentModel.rightSequenceNumbers, 
        										sequenceNumbers[1]
        									);
        							editor.getTextView().addRuler(rightSequenceNumberRuler, 0);
        						}
        						
        						var cobolStyler = new mCobolStyler.CobolStyler("NONE");
        						var styleParser = new mStyleParser.StyleParser(cobolStyler, intro);
        						var textStyler = new mTextStyler.TextStyler(editor, styleParser );
        						textStyler.initialize();
        					});} else {
        						var defaultPluginURLs = [];
            					
            					codeEdit.create({_defaultPlugins: defaultPluginURLs, parent: "embeddedEditor", contentType: "text/plain", contents: http.responseText}).then(function(editorViewer) {
            						
            						editorViewer.readonly = true;
            		
            						var editor = editorViewer.editor;
            		
            						if (editorViewer.settings) {
            							editorViewer.settings.contentAssistAutoTrigger = false;
            							editorViewer.settings.showOccurrences = false;
            							editorViewer.settings.showMargin = true;
            						}
            						
            						
            					});
        					}
    					} else {
    						//console.debug(http);
    					}
					}
					http.send(params);
					
	
    			});
			});