/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "dojox/layout/TableContainer", "dijit/form/TextBox",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function (ContentPane, TableContainer, TextBox, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function baseDefinition (data) {
		var definitionTable = new TableContainer( {
			labelWidth : 150,
		} );
		
		var externalName = new TextBox( {
			label : PacbaseEditor.BLOCKBASE_EXTERNAL_NAME,
			value : data.externalName,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( externalName );
		
		var blockType = new TextBox( {
			label : PacbaseEditor.BLOCKBASE_TYPE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.blockType),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( blockType );
		
		if ("_DB" == data.blockType.value || "_20" == data.blockType.value 
				|| "_D0" == data.blockType.value || "_D2" == data.blockType.value 
				|| "_D4" == data.blockType.value || "_I1" == data.blockType.value 
				|| "_I2" == data.blockType.value || "_I3" == data.blockType.value 
				|| "_M1" == data.blockType.value || "_M2" == data.blockType.value 
				|| "_M3" == data.blockType.value || "_M4" == data.blockType.value 
				|| "_S1" == data.blockType.value || "_S3" == data.blockType.value 
				|| "_TD" == data.blockType.value ) {
			var schemaName = new TextBox( {
				label : PacbaseEditor.BLOCKBASE_SCHEMA_EXTERNAL_NAME,
				value : data.schemaName,
				disabled : true,
				style : {
					"width" : rppDefaultTextWidth
				}
			} );
			definitionTable.addChild( schemaName );
		}
		
		var version = new TextBox( {
			label : PacbaseEditor.BLOCKBASE_VERSION_NUMBER,
			value : data.version,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( version );
		
		return definitionTable;
	}

	return {
		getDetailDefinition : function ( data, type, project, streamId, compentId, fileItemId ) {
			var detailDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content :  "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
				    + "<strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
							+ string.substitute( PacbaseEditor.SEGMENT_EDIT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			
			detailDefinition.addChild( baseDefinition(data) );

			return detailDefinition;
		}
	};
} );