/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  
		"./blockbaseOverviewPane", /*The default overviews */ 
		"./keywordsPane", /* The keywords pane */
		"./blockbaseDefinition",
		"./blockbaseDCLines",
		"./blockbaseDHLines",
		"./blockbaseDRLines",
		"./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, blockbaseOverviewPane, keywordsPane, blockbaseDefinition, blockbaseDCLines, blockbaseDHLines ,blockbaseDRLines, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {			
			var tc = new TabContainer( {
			} );
		
			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( blockbaseOverviewPane.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// Definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.PROGRAM_SECTION_HEADER,
			} );
			cpDefinition.addChild( blockbaseDefinition.getDetailDefinition( data, type, project, streamId, compentId, fileItemId  ) );
			tc.addChild( cpDefinition );			
			
			// -DC
			if ("_DB" == data.blockType.value || "_20" == data.blockType.value 
					|| "_D0" == data.blockType.value || "_D2" == data.blockType.value 
					|| "_D4" == data.blockType.value || "_I1" == data.blockType.value 
					|| "_I2" == data.blockType.value || "_I3" == data.blockType.value 
					|| "_M1" == data.blockType.value || "_M2" == data.blockType.value 
					|| "_M3" == data.blockType.value || "_M4" == data.blockType.value 
					|| "_S1" == data.blockType.value || "_S3" == data.blockType.value 
					|| "_TD" == data.blockType.value ) {
				var cpDefinition = new ContentPane( {
					title : PacbaseEditor.BLOCKBASE_DC,
				} );
				cpDefinition.addChild( blockbaseDCLines.getDetailDCLines( data, type, project, streamId, compentId, fileItemId  ) );
				tc.addChild( cpDefinition );	
			}
			
			// -DH
			if ("_DL" == data.blockType.value || "_DP" == data.blockType.value 
					|| "_DR" == data.blockType.value || "_IP" == data.blockType.value 
					|| "_PF" == data.blockType.value || "_LF" == data.blockType.value 
					|| "_IS" == data.blockType.value || "_PS" == data.blockType.value 
					|| "_PC" == data.blockType.value ) {
				var cpDefinition = new ContentPane( {
					title : PacbaseEditor.BLOCKBASE_DH,
				} );
				cpDefinition.addChild( blockbaseDHLines.getDetailDHLines( data, type, project, streamId, compentId, fileItemId  ) );
				tc.addChild( cpDefinition );	
			}			
			
			// -DR
			if ("_Q2" == data.blockType.value || "_Q3" == data.blockType.value 
					|| "_QC" == data.blockType.value || "_QN" == data.blockType.value 
					|| "_QS" == data.blockType.value || "_QT" == data.blockType.value 
					|| "_QR" == data.blockType.value || "_QP" == data.blockType.value 
					|| "_QB" == data.blockType.value || "_QU" == data.blockType.value					
					|| "_QY" == data.blockType.value ) {
				var cpDefinition = new ContentPane( {
					title : PacbaseEditor.BLOCKBASE_DR,
				} );
				cpDefinition.addChild( blockbaseDRLines.getDetailDRLines( data, type, project, streamId, compentId, fileItemId  ) );
				tc.addChild( cpDefinition );	
			}			
			
			// -G Lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			cpGLines.addChild( gLinesPane.getGLines( data, type,  true, false, true, true, streamId, project ) );
			tc.addChild( cpGLines );
			
			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );