/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/CheckBox",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, CheckBox, PacbaseEditor, PacEnumerationLabel, typeDict ) {	
	
	function baseDefinition (data, streamId, project) {
		
		var definitionTable = new TableContainer( {
			labelWidth : rppDefaultLabelWidth,
		} );

		var  generationType = new TextBox( {
			label : PacbaseEditor.COPY_GENERATION,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.generationType),
			style : {
				"width" : "350px"
			},
			disabled : true
		} );
		definitionTable.addChild( generationType );
		
		var dataStructure = 
			new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget(PacbaseEditor.COPY_DATA_STRUCTURE, data.dataStructure, true, streamId, project);
		
		definitionTable.addChild( dataStructure );
		
		return definitionTable;	
		
	}
	
	function baseDefinitionSuite (data, streamId, project) {
		
		var definitionTable = new TableContainer( {
			labelWidth : rppDefaultLabelWidth,
		} );
		
		if (data.generationType.value !== "_DSQC1" ){
			
		var inputAidParameter = new CheckBox( {					
			label : PacbaseEditor.COPY_INPUT_AID_PARAMETER,		
			checked : data.inputAidParameter == "true",
			disabled : true
		} );
		definitionTable.addChild( inputAidParameter );
		
		if (data.inputAidParameter == "false"){ 
		
		var  cobolType = new TextBox( {
			label : PacbaseEditor.COPY_COBOL_TYPE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.cobolType),
			style : {
				"width" : "350px"
			},
			disabled : true
		} );
		definitionTable.addChild( cobolType );	
		
		var  externalName = new TextBox( {
			label : PacbaseEditor.COPY_EXTERNAL_NAME,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.externalName),
			style : {
				"width" : "350px"
			},
			disabled : true
		} );
		definitionTable.addChild( externalName );
		
		var  DSCodeType = new TextBox( {
			label : PacbaseEditor.COPY_CODIF_SPECIF,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.DSCodeType),
			style : {
				"width" :  "350px"
			},
			disabled : true
		} );
		definitionTable.addChild( DSCodeType );	
		
		var datastructureCode = new TextBox( {
			label : PacbaseEditor.COPY_DATA_STRUCTURE_CODE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.datastructureCode),
			style : {
				"width" :  "350px"
			},
			disabled : true
		} );
		definitionTable.addChild( datastructureCode );	
		
		var cobolLocationCode = new TextBox( {
			label : PacbaseEditor.COPY_COBOL_LOCATION_CODE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.cobolLocationCode),
			style : {
				"width" :  "350px"
			},
			disabled : true
		} );
		definitionTable.addChild( cobolLocationCode );		
		
		var  formatType = new TextBox( {
			label : PacbaseEditor.COPY_FORMAT_TYPE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.formatType),
			style : {
				"width" :  "350px"
			},
			disabled : true
		} );
		definitionTable.addChild( formatType );	
		
		var recordType = new TextBox( {
			label : PacbaseEditor.COPY_COBOL_RECORD_TYPE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.recordType),
			style : {
				"width" : "350px"
			},
			disabled : true
		} );
		definitionTable.addChild( recordType );
		
		var recordLevel = new TextBox( {
			label : PacbaseEditor.COPY_COBOL_RECORD_LEVEL,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.recordLevel),
			style : {
				"width" :  "350px"
			},
			disabled : true
		} );
		definitionTable.addChild( recordLevel );
		}
		}
		if (data.generationType.value == "_DSQC1" ){
			
			var inputAidParameter = new CheckBox( {
				label : PacbaseEditor.COPY_INPUT_AIDSQ_PARAMETER,
				checked : data.inputAidParameter == "true",
				disabled : true
			} );
			definitionTable.addChild( inputAidParameter );
			
			if (data.inputAidParameter == "false"){ 
			
			var  cobolType = new TextBox( {
				label : PacbaseEditor.COPY_COBOL_TYPE,
				value : rppEnumVDislayValue(PacEnumerationLabel, data.cobolType),
				style : {
					"width" : "350px"
				},
				disabled : true
			} );
			definitionTable.addChild( cobolType );	
		
			var  externalName = new TextBox( {
				label : PacbaseEditor.COPY_EXTERNAL_NAME,
				value : rppEnumVDislayValue(PacEnumerationLabel, data.externalName),
				style : {
					"width" : "350px"
				},
				disabled : true
			} );			
			definitionTable.addChild( externalName );
			
			var datastructureCode = new TextBox( {
				label : PacbaseEditor.COPY_DATA_STRUCTURE_CODE,
				value : rppEnumVDislayValue(PacEnumerationLabel, data.datastructureCode),
				style : {
					"width" :  "350px"
				},
				disabled : true
			} );
			definitionTable.addChild( datastructureCode );	
			
			var pacBlockBase = 
				new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget(PacbaseEditor.COPY_PAC_BLOCKBASE, data.pacBlockBase, true, streamId, project);
			
			definitionTable.addChild( pacBlockBase );
			
			
			var presIndicator = new TextBox( {
				label : PacbaseEditor.COPY_PRES_INDICATOR,
				value : rppEnumVDislayValue(PacEnumerationLabel,data.presIndicator),
				style : {
					"width" :  "350px"
				},
				disabled : true
			} );
			definitionTable.addChild( presIndicator);	
		}
		}
		return definitionTable;	
	}
	
	return {
		getDetailDefinition : function ( data, type, project, streamId, compentId, fileItemId  ) {
			var detailDefinition;
			
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content : "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
				    + "<strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
							+ string.substitute( PacbaseEditor.SEGMENT_EDIT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			detailDefinition.addChild( baseDefinition(data, streamId, project) );
			detailDefinition.addChild( baseDefinitionSuite(data) );
			
			return detailDefinition;
		}
	};
	
} );