/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "dojo/request/xhr", "com.ibm.teampdp.query.engine.web/ui/internal/page/jsModules/designFileContent"
], function ( ContentPane, xhr, designFileContent ) {
	return {
		createPane : function ( streamId, fileItemId, compentId, workingProject, project, type, name ) {
			var cp = new ContentPane();
			// Ajax for design file
			var promiseContent = xhr( net.jazz.ajax.contextRoot() + "/service/com.ibm.teampdp.query.engine.common.IRppDesignFileService", {
				method : "POST",
				// synchronous ensure that contentPane of content is well prepared.
				data : {
					streamId : streamId,
					fileItemId : fileItemId,
					compentId : compentId,
					project : project,
					type : type,
					name : name
				},
				handleAs : "json"
			} ).then( function ( data ) {
				var newType = type
				if (type == "pacblockbase") {
					if ("_DB" == data.blockType.value || "_20" == data.blockType.value 
							|| "_D0" == data.blockType.value || "_D2" == data.blockType.value 
							|| "_D4" == data.blockType.value || "_I1" == data.blockType.value 
							|| "_I2" == data.blockType.value || "_I3" == data.blockType.value 
							|| "_M1" == data.blockType.value || "_M2" == data.blockType.value 
							|| "_M3" == data.blockType.value || "_M4" == data.blockType.value 
							|| "_S1" == data.blockType.value || "_S3" == data.blockType.value 
							|| "_TD" == data.blockType.value ) {
						newType = "PacBlockBase_Codasyl";
					}
					if ("_DL" == data.blockType.value || "_DP" == data.blockType.value 
							|| "_DR" == data.blockType.value || "_IP" == data.blockType.value 
							|| "_PF" == data.blockType.value || "_LF" == data.blockType.value 
							|| "_IS" == data.blockType.value || "_PS" == data.blockType.value 
							|| "_PC" == data.blockType.value ) {
						newType = "PacBlockBase_Hierarchical";
					}
					if ("_Q2" == data.blockType.value || "_Q3" == data.blockType.value 
							|| "_QC" == data.blockType.value || "_QN" == data.blockType.value 
							|| "_QS" == data.blockType.value || "_QT" == data.blockType.value 
							|| "_QR" == data.blockType.value || "_QP" == data.blockType.value 
							|| "_QB" == data.blockType.value || "_QU" == data.blockType.value					
							|| "_QY" == data.blockType.value ) {
						newType = "PacBlockBase_Relational";
					}
				}
				if ( type == "pacdialog" ) {
					if ("_C" == data.dialogType.value) {
						newType = "pacDialogClientServer";
					}					
				}
				if ( type == "pacscreen" ) {
					var dialogType = data.dialogType.value;
					if ("_Inherited" == dialogType) {
						dialogType = data.dialog.dialogType.value;
					}
					if ("_C" == dialogType) {
						newType = "PacScreenClientServer";
					}
					if ("_MC" == dialogType) {
						newType = "PacScreenClientMonitor";
					}
					if ("_SC" == dialogType) {
						newType = "PacScreenClientSubMonitor";
					}
					if ("_MW" == dialogType) {
						newType = "PacScreenClientWebMonitor";
					}
				}
				if ( type == "pacserver" ) {
					if ("_E" == data.dialogType.value) {
						newType = "PacDialogServer_E";
					}
					if ("_FM" == data.dialogType.value) {
						newType = "PacDialogServer_FM";
					}
					if ("_IT" == data.dialogType.value) {
						newType = "PacDialogServer_IT";
					}
					if ("_MS" == data.dialogType.value) {
						newType = "PacDialogServer_MS";
					}
					if ("_MV" == data.dialogType.value) {
						newType = "PacDialogServer_MV";
					}
					if ("_SI" == data.dialogType.value) {
						newType = "PacDialogServer_SI";
					}
					if ("_ST" == data.dialogType.value) {
						newType = "PacDialogServer_ST";
					}	
				}
				if ( type == "dataaggregate" ) {
					if ("_V" == data.extensions[0].dataAggregateType.value) {
						newType = "PacDALogicalView"
					}
					if ("_G" == data.extensions[0].dataAggregateType.value) {
						newType = "PacDATable"
					}
				}
				if ( type == "dataunit" ) {
					if ("_V" == data.extensions[0].dataStructureType.value) {
						newType = "PacDataUnitLV"
					}
					if ("_G" == data.extensions[0].dataStructureType.value || "_T" == data.extensions[0].dataStructureType.value
							|| "_M" == data.extensions[0].dataStructureType.value || "_N" == data.extensions[0].dataStructureType.value) {
						newType = "PacDataUnitTable"
					}
				}
				cp.addChild( designFileContent.getDesignFileContent( data, type, workingProject, streamId, compentId, fileItemId ) );
				cp.set( "newTypeIcon", newType );
				return cp;
			}, function ( err ) {
				displayRppError( err );
				return cp;
			} );
			return promiseContent;
		}
	};
} );