/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "./generalInfoPane", "./dataElementDefinition", "./keywordsPane", "./generationParameterPane",
		"./dataElementDLines", "./gLinesPane"
], function ( ContentPane, generalInfoPane, dataElementDefinition, keywordsPane, generationParameterPane, dataElementDLines, gLinesPane ) {
	return {
		getOverview : function ( data, type, project, streamId, compentId, fileItemId ) {
			var overview = new ContentPane( {
				title : data.name,
				closable : true,
			} );

			// set the general information
			overview.addChild( generalInfoPane.getGeneralInfo( type, project, data.name, data.label ) );

//			// set the data element definition
//			var dataDescriptionExtension = data.dataDescription.extensions.filter( function ( object ) {
//				return object.facet === "pacbase" && object[ "class" ] === "PacDataElementDescription";
//			} );
//			if ( dataDescriptionExtension.length === 1 ) {
//				var definition = dataElementDefinition.getOverviewDefinition( dataDescriptionExtension[ 0 ], data.dataDescription.label,
//						type, streamId, project );
//				overview.addChild( definition );
//			}

			// set the keywords
			overview.addChild( keywordsPane.getOverviewKeywords( data.keywords, type ) );

			// set generation parameters , d lines and g lines
			var extensions = data.extensions.filter( function ( object ) {
				return object.facet === "pacbase" && object[ "class" ] === "PacDataElement";
			} );

			if ( extensions.length === 1 ) {
				// set generation parameters
				overview.addChild( generationParameterPane.getOverviewLibraryCall( extensions[ 0 ].generationParameter, type, project, streamId ) );
				// set d lines
				// overview.addChild( dataElementDLines.getOverviewDLines( extensions[ 0 ].DLines, type ) );
				// set g lines
				// overview.addChild( gLinesPane.getOverviewGLines( type ) );
			}

			return overview;
		}
	};
} );