/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane", "./dataElementOverview", "./dataElementDefinition", "./dataElementDLines",
		"./keywordsPane", "./gLinesPane", "dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, dataElementOverview, dataElementDefinition, dataElementDLines, keywordsPane, gLinesPane, PTEditor,
		PacbaseEditor ) {
	return {
		getDataElementTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );

			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( dataElementOverview.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );

			// Definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.DATA_ELEMENT_SECTION_HEADER,
			} );
			// Check pacbase
			var dataDescriptionExtensions = data.dataDescription.extensions.filter( function ( object ) {
				return object.facet === "pacbase";
			} );
			if ( dataDescriptionExtensions.length === 1 ) {
				cpDefinition.addChild( dataElementDefinition.getDetailDefinition( dataDescriptionExtensions[ 0 ],
						data.name, data.label, type, streamId, project ) );
				tc.addChild( cpDefinition );
			}


			// -D lines
			var cpDLines = new ContentPane( {
				title : PacbaseEditor.DLINE_TABTEXT,
			} );
			// -G Lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			// Check pacbase
			var extensions = data.extensions.filter( function ( object ) {
				return object.facet === "pacbase";
			} );
			if ( extensions.length === 1 ) {
				cpDLines.addChild( dataElementDLines.getDetailDLines( data, type ) );
				cpGLines.addChild( gLinesPane.getGLines( data, type, true, true, false, false, streamId, project ) );
				tc.addChild( cpDLines );
				tc.addChild( cpGLines );
			}

			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );