/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/


define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dojo/string",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, string, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	return {
		getOverviewDefinition : function ( data, type ) {
			var extension = data.extensions[ 0 ]			
			
			var overviewDefinition = new ContentPane( {
				content : "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
			    + "<hr><strong>" + PacbaseEditor.DATA_STRUCTURE_EDIT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><P>"
						+ string.substitute( PacbaseEditor.DATA_STRUCTURE_EDIT_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>",
			} );

			var definitionTable = new TableContainer( {
				labelWidth : rppDefaultLabelWidth,
			} );

			var texComment = new TextBox( {
				label : PacbaseEditor.DATA_STRUCTURE_COMMENTS,
				value : extension.comments,
				disabled : true,
				style : {
					"width" : rppDefaultTextWidth
				}
			} );
			var texType = new TextBox( {
				label : PacbaseEditor.DATA_STRUCTURE_TYPE,
				value : PacEnumerationLabel[ extension.dataStructureType[ "class" ] + extension.dataStructureType[ "value" ] ],
				disabled : true,
				style : {
					"width" : rppDefaultTextWidth
				}

			} );
			var texLanguage = new TextBox( {
				label : PacbaseEditor.GENERATED_SKELETON_LANGUAGE,
				value : PacEnumerationLabel[ extension.skeletonLanguage[ "class" ] + extension.skeletonLanguage[ "value" ] ],
				disabled : true,
				style : {
					"width" : rppDefaultTextWidth
				}

			} );
			definitionTable.addChild( texComment );
			definitionTable.addChild( texType );
			definitionTable.addChild( texLanguage );

			overviewDefinition.addChild( definitionTable );
			return overviewDefinition;
		},
	};
} );