/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "dojo/string", "dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( ContentPane, string, PacbaseEditor, typeDict ) {
	return {
		getOverviewLSLines : function ( components, type ) {
			var overviewLSLines = new ContentPane( {
				content : "<hr><strong>" + PacbaseEditor.LSLINE_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><P>"
						+ string.substitute( PacbaseEditor.LSLINE_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>",
			} );

			if ( components.length != 0 ) {
				var lsLinesContent = "<ul>"
				components.forEach( function ( component ) {
					lsLinesContent += "<li>";
					if ( component.dataDefinition != undefined && component.dataDefinition != "" ) {
						var dataDefinition = component.dataDefinition;
						lsLinesContent += dataDefinition[ "name" ] + " (";
						lsLinesContent += typeDict[ dataDefinition[ "class" ] ] + ") ";
						lsLinesContent += dataDefinition[ "label" ];
					}
					lsLinesContent += "</li>";
				} );
				lsLinesContent += "</ui>";
				var lsLinesPane = new ContentPane( {
					content : lsLinesContent,
					style : {
						height : "100px"
					}
				} );
				overviewLSLines.addChild( lsLinesPane );
			}
			return overviewLSLines;
		},

		
	};
} );