/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "./generalInfoPane", "./dataStructureDefinition", "./generationParameterPane", "./gLinesPane", "./dataStructureLSLines",
		"./keywordsPane",
], function ( ContentPane, generalInfoPane, dataStructureDefinition, generationParameterPane, gLinesPane, dataStructureLSLines, keywordsPane ) {
	return {
		getOverview : function ( data, type, project, streamId, compentId, fileItemId ) {
			var overview = new ContentPane( {
				title : data.name,
				closable : true,
			} );

			// set the general information
			overview.addChild( generalInfoPane.getGeneralInfo( type, project, data.name, data.label ) );

			// set the data unit definition
			/*var dataExtension = data.extensions.filter( function ( object ) {
				return object.facet === "pacbase" && object[ "class" ] === "PacDataUnit";
			} );
			if ( dataExtension.length === 1 ) {
				overview.addChild( dataStructureDefinition.getOverviewDefinition( dataExtension[ 0 ], type ) );
			}*/

			// set generation parameters , g lines
			var extensions = data.extensions.filter( function ( object ) {
				return object.facet === "pacbase" && object[ "class" ] === "PacDataUnit";
			} );

			if ( extensions.length === 1 ) {
				// set generation parameters
				overview.addChild( generationParameterPane.getOverviewLibraryCall( extensions[ 0 ].generationParameter, type, project, streamId ) );
				// set g lines
				// overview.addChild( gLinesPane.getOverviewGLines( type ) );
			}

			// set LS Lines
			// overview.addChild( dataStructureLSLines.getOverviewLSLines( data.components, type ) );

			// set the keywords
			overview.addChild( keywordsPane.getOverviewKeywords( data.keywords, type ) );

			return overview;
		}
	};
} );