/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", 
		"./dataElementTab", "./segmentTab", "./dataStructureTab", 
		"./programTab", "./macroTab", "./dialogTab", "./screenTab","./dialogServerTab","./serverTab",
		"./textTab", "./libraryTab", "./inputAidTab", "./reportTab", "./errorLabelTab","./copybookTab",
		"./dialogFolderTab", "./folderTab", "./blockbaseTab", "./metaDataAggregateTab", "./metaEntityTab",
		"./metaEntityTypeTab", "./userEntityTab", "./dialogCommunicationMonitorTab", "./communicationMonitorTab",
		"./dialogFolderViewTab", "./folderViewTab", "./volumeTab", "./defaultTab"
], function ( ContentPane, dataElementTab, segmentTab, dataStructureTab, programTab, macroTab, dialogTab, screenTab, dialogServerTab, serverTab, textTab, libraryTab, inputAidTab, reportTab, errorLabelTab, copybookTab, dialogFolderTab, folderTab, blockbaseTab, metaDataAggregateTab, metaEntityTab, metaEntityTypeTab, userEntityTab, dialogCommunicationMonitorTab, communicationMonitorTab, dialogFolderViewTab, folderViewTab, volumeTab, defaultTab ) {
	return {
		getDesignFileContent : function ( data, type, project, streamId, compentId, fileItemId ) {
			var cp = new ContentPane();
			if ( type === "dataelement" ) {
				cp = dataElementTab.getDataElementTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "dataaggregate" ) {
				cp = segmentTab.getSegmentTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "dataunit" ) {
				cp = dataStructureTab.getDataStructureTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacprogram" ) {
				cp = programTab.getProgramTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacmacro" ) {
				cp = macroTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacdialog" ) {
				cp = dialogTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacscreen" ) {
				cp = screenTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacdialogserver" ) {
				cp = dialogServerTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;	
			} else if ( type === "pacserver" ) {
				cp = serverTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;				
			} else if ( type === "pactext" ) {
				cp = textTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "paclibrary" ) {
				cp = libraryTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;	
			} else if ( type === "pacinputaid" ) {
				cp = inputAidTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;	
			} else if ( type === "pacreport" ) {
					cp = reportTab.getTab( data, type, project, streamId, compentId, fileItemId );
					return cp;		
			} else if ( type === "pacerrorlabel" ) {
				cp = errorLabelTab.getTab( data, type, project, streamId, compentId, fileItemId );
		        return cp;		
			} else if ( type === "paccopybook" ) {
				cp = copybookTab.getTab( data, type, project, streamId, compentId, fileItemId );
		        return cp;		
			} else if ( type === "pacdialogfolder" ) {
				cp = dialogFolderTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "pacfolder" ) {
				cp = folderTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;
			} else if ( type === "pacblockbase" ) {
				cp = blockbaseTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "metadataaggregate" ) {
				cp = metaDataAggregateTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "metaentity" ) {
				cp = metaEntityTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "metaentitytype" ) {
				cp = metaEntityTypeTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "userentity" ) {
				cp = userEntityTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "pacdialogcommunicationmonitor" ) {
				cp = dialogCommunicationMonitorTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "paccommunicationmonitor" ) {
				cp = communicationMonitorTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "pacdialogfolderview" ) {
				cp = dialogFolderViewTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "pacfolderview" ) {
				cp = folderViewTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;		
			} else if ( type === "pacvolume" ) {
				cp = volumeTab.getTab( data, type, project, streamId, compentId, fileItemId );				
				return cp;		
			}
			else {
				cp = defaultTab.getTab( data, type, project, streamId, compentId, fileItemId );
				return cp;								
			}
		}
	};
} );