/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", 
		"./generalInfoPane", 
		"./generationParameterPane", 
		"./keywordsPane",
], function ( ContentPane, generalInfoPane, generationParameterPane, keywordsPane ) {
	return {
		getOverview : function ( data, type, project, streamId, compentId, fileItemId ) {
			var overview = new ContentPane( {
				title : data.name,
				closable : true,
			} );
			
			// set the general information
			overview.addChild( generalInfoPane.getGeneralInfo( type, project, data.name, data.label ) );
			
			// set generation parameters
			if ( data.generationParameter != undefined )
				overview.addChild( generationParameterPane.getOverviewLibraryCall( data.generationParameter, type, project, streamId ) );

			// set the keywords
			overview.addChild( keywordsPane.getOverviewKeywords( data.keywords, type ) );

			return overview;
		}
	};
} );