/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/CheckBox",
		"com.ibm.teampdp.query.engine.web/ui/internal/page/jsModules/widgets/CommonDialogFolderDefinition",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, CheckBox, CommonDialogFolderDefinition, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function baseDefinition (data, streamId, project) {
		var commonDialogFolderDefinition = 
			new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogFolderDefinition("", data);
	    
		return commonDialogFolderDefinition;
	}

	return {
		getOverviewDefinition : function ( type ) {
			var overviewDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				overviewDefinition = new ContentPane( {
					content : "<hr><strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><P>"
							+ string.substitute( PacbaseEditor.SEGMENT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			overviewDefinition.addChild( baseDefinition(data) );
			return overviewDefinition;
		},
		getDetailDefinition : function ( data, type, streamId, project ) {
			var detailDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content : "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
				    + "<strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><p>"
							+ string.substitute( PacbaseEditor.SEGMENT_EDIT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			detailDefinition.addChild( baseDefinition(data, streamId, project) );

			return detailDefinition;
		}
	};
} );