/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017, 2018. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  "./dialogServerOverview", "./dialogServerDefinition", "./dialogServerComplement", "./serverCSLines", "./cpLinesPane", "./keywordsPane", "./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, dialogServerOverview, dialogServerDefinition, dialogServerComplement, CSLines, cpLinesPane, keywordsPane, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );

			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( dialogServerOverview.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// Definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.PROGRAM_SECTION_HEADER,
			} );
			cpDefinition.addChild( dialogServerDefinition.getDetailDefinition( data, type, streamId, project  ) );
			tc.addChild( cpDefinition );			

			// Complement du dialogue
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.DIALOG_COMPLEMENT,
			} );
			cpDefinition.addChild( dialogServerComplement.getDetailDefinition( data, type, project, streamId ) );
			tc.addChild( cpDefinition );			

			// CS Lines
			var cpCSLines = new ContentPane( {
				title : PacbaseEditor.CSLINE_SECTION_HEADER,
			} );
			cpCSLines.addChild( CSLines.getDetailCSLines( data, type, project, streamId ) );
			tc.addChild( cpCSLines );

			// CP Lines
			var cpCPLines = new ContentPane( {
				title : PacbaseEditor.CPLINE_TABTEXT,
			} );
			cpCPLines.addChild( cpLinesPane.getCPLines( data, type, streamId, project ) );
			tc.addChild( cpCPLines );

			// -G Lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			cpGLines.addChild( gLinesPane.getGLines( data, type,  true, true, true, true, streamId, project ) );
			tc.addChild( cpGLines );
			
			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );