/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/CheckBox",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, CheckBox, PacbaseEditor, PacEnumerationLabel, typeDict ) {
		
	function baseDefinition (data, streamId, project) {
		

		
		var definitionTable = new TableContainer( {
			labelWidth : rppDefaultLabelWidth,
		} );

		


		var  generationType = new TextBox( {
			label : PacbaseEditor.ERROR_LABEL_TYPE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.generationType),
			disabled : true,
			style : {
				"width" : rppDefaultLabelWidth
			}
		} );
		definitionTable.addChild( generationType );
		
		//libellé erreur pour structure de donnée
		if ( data.generationType.value == "_B") {
			var dataStructure = 
				new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget(PacbaseEditor.ERROR_LABEL_DATA_STRUCTURE, data.dataStructure, true, streamId, project);
		
			definitionTable.addChild( dataStructure );
		}
		//libellé erreur pour serveur
		if ( data.generationType.value == "_S") {
			var server = 
				new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget(PacbaseEditor.ERROR_LABEL_DIAL_SERVER, data.pacDialogServer, true, streamId, project);
			
			definitionTable.addChild( server );
		}
		//libellé erreur pour dialogue standart ou client
		if (data.generationType.value == "_O" ){
			var client = 
				new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget(PacbaseEditor.ERROR_LABEL_DIAL_STANDART, data.pacDialog, true, streamId, project);
			
			definitionTable.addChild( client );
		}
		//libellé erreur pour client
		if (data.generationType.value == "_C" ){
			var client = 
				new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget(PacbaseEditor.ERROR_LABEL_DIAL_CLIENT, data.pacDialog, true, streamId, project);
			
			definitionTable.addChild( client );
		}
		
		var  externalName = new TextBox( {
			label : PacbaseEditor.ERROR_LABEL_EXTERNAL_NAME,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.externalName),
			disabled : true,
			style : {
				"width" : rppDefaultLabelWidth
			}
		} );
		definitionTable.addChild( externalName );
		
		var  generatedLanguage = new TextBox( {
			label : PacbaseEditor.ERROR_LABEL_GENERATED_LANGAGE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.generatedLanguage),
			disabled : true,
			style : {
				"width" : rppDefaultLabelWidth
			}
		} );
		definitionTable.addChild(generatedLanguage);
		
		var  generationOption = new TextBox( {
			label : PacbaseEditor.ERROR_LABEL_GENERATION_OPTION,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.generationOption),
			disabled : true,
			style : {
				"width" : rppDefaultLabelWidth
			}
		} );
		definitionTable.addChild(generationOption);
		
		return definitionTable;	
	}
	return {
		getDetailDefinition : function ( data, type, project, streamId, compentId, fileItemId  ) {
			var detailDefinition;
			
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content :  "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
				    + "<strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
							+ string.substitute( PacbaseEditor.SEGMENT_EDIT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			detailDefinition.addChild( baseDefinition(data, streamId, project) );

			return detailDefinition;
		}
	};
} );