/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  
		"./errorLabelOverviewPane", /*The error label overviews */
		"./errorLabelDefinition", 
		"./entitiesSelectionLinesPane",
		"./keywordsPane", /* The keywords pane */
		"./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, errorLabelOverviewPane, errorLabelDefinition,entitiesSelectionLinesPane, keywordsPane, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );
		
			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( errorLabelOverviewPane.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.ERROR_LABEL_SECTION_HEADER,
			} );
			cpDefinition.addChild( errorLabelDefinition.getDetailDefinition( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpDefinition);
			
			// selection
			var cpSelection = new ContentPane( {
				title : PacbaseEditor.COPY_SELECTION_TABTEXT,
			} );
			cpSelection.addChild( entitiesSelectionLinesPane.getDetailLines( data, type, project, streamId, compentId, fileItemId, PacbaseEditor.ERROR_LABEL_SELECTION_TABTEXT, 
					PacbaseEditor.ERROR_LABEL_SELECTED_ENTITY_LIST, 
					PacbaseEditor.ERROR_LABEL_SELECTED_LIST, PacbaseEditor.ERROR_LABEL_COLUMN_TOOL_TIP_SELECTED_LIST) );
			tc.addChild( cpSelection );
			
			// -G Lines
			var gGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			gGLines.addChild( gLinesPane.getGLines( data, type,  true, false, false, false, streamId, project ) );
			tc.addChild( gGLines );		
			

			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );