/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  "./folderViewOverview", "./folderViewDefinition", "./folderViewCSLines", "./keywordsPane",  "./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, folderViewOverview, folderViewDefinition, folderViewCSLines, keywordsPane, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );
		
			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( folderViewOverview.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// Definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.PROGRAM_SECTION_HEADER,
			} );
			cpDefinition.addChild( folderViewDefinition.getDetailDefinition( data, type, project, streamId ) );
			tc.addChild( cpDefinition );	

			// CSLines / composition
			var cpCSLines = new ContentPane( {
				title : PacbaseEditor.FOLDER_CSLINE_TABTEXT,
			} );

			cpCSLines.addChild( folderViewCSLines.getDetailCSLines( data, type, project, streamId ) );
			tc.addChild( cpCSLines );	

			// -G Lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			cpGLines.addChild( gLinesPane.getGLines( data, type, true, false, false, false, streamId, project ) );
			tc.addChild( cpGLines );
			
			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );