/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/Textarea",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, Textarea, PTEditor, PacbaseEditor, typeDict ) {
	return {
		getGeneralInfo : function ( type, project, name, label ) {
			var generalInfo;
			require( [
				"dojo/string"
			], function ( string ) {
				var typeString = typeDict[ type ] == undefined ? type : typeDict[ type ];
				generalInfo = new ContentPane( {
					content : "<strong>" + typeDict[ type ] + " " + name + " : " + label + "</strong><P>"
		            + "<strong>" + PTEditor.GENERAL_HEADER + PacbaseEditor.SEPARATOR + "</strong><P>" + string.substitute( PTEditor.GENERAL_DESCRIPTION, [
						typeString
					] ) + "</p>",
				} );
			} );
			var generalInfoTable = new TableContainer( {
				cols : 1,
				labelWidth : 150,
				//valueWidth : 200,
			} );

			var tex1 = new TextBox( {
				label : PTEditor.WORKING_CONTEXT,
				value : project,
				disabled : true,
				style : {
					width : "300px"
				}
			} );
			var tex2 = new TextBox( {
				label : PTEditor.NAME,
				value : name,
				disabled : true,
				style : {
					width : "300px"
				}
			} );
			var tex3 = new Textarea( {
				label : PTEditor.LABEL,
				value : label,
				disabled : true,
				style : {
					width : "302px"
				}
			} );
			generalInfoTable.addChild( tex1 );
			generalInfoTable.addChild( tex2 );
			generalInfoTable.addChild( tex3 );
			generalInfo.addChild( generalInfoTable );
			return generalInfo;
		}
	};
} );