/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
        "dojox/layout/TableContainer", "dijit/form/TextBox",		
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dijit/layout/ContentPane",
		"./generalInfoPane", 
		"./generationParameterPane", 
		"./keywordsPane",
], function ( TableContainer, TextBox, PacbaseEditor, ContentPane, generalInfoPane, generationParameterPane, keywordsPane ) {
	
	function getValue ( value ) {
		if (value == "_C") {
			return PacbaseEditor.INPUT_AID_TYPE_VALUE_C;
		}
		if (value == "_G") {
			return PacbaseEditor.INPUT_AID_TYPE_VALUE_G;
		}
		return PacbaseEditor.INPUT_AID_TYPE_VALUE_O;
	}
	return {
		getOverview : function ( data, type, project, streamId, compentId, fileItemId ) {
			var overview = new ContentPane( {
				title : data.name,
				closable : true,
			} );
			
			// set the general information
			overview.addChild( generalInfoPane.getGeneralInfo( type, project, data.name, data.label ) );
			
			var inputAidType = new TableContainer( {
				labelWidth : 150,
			} );
			var iaType = new TextBox( {
				label : PacbaseEditor.INPUT_AID_TYPE,
				value : getValue(data.type.value),
				disabled : true,
				style : {
					width : "300px"
				}
			} );
			inputAidType.addChild( iaType );
			overview.addChild(inputAidType);
			
			// set generation parameters
			if ( data.generationParameter != undefined )
				overview.addChild( generationParameterPane.getOverviewLibraryCall( data.generationParameter, type, project, streamId ) );

			// set the keywords
			overview.addChild( keywordsPane.getOverviewKeywords( data.keywords, type ) );

			return overview;
		}
	};
} );