/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  
		"./inputAidOverviewPane", /*The default overviews */ 
		"./keywordsPane", /* The keywords pane */		
		"./gLinesPane",		
		"./inputAidDLines",
		"./inputAidSymbolicValues",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, inputAidOverviewPane, keywordsPane, gLinesPane, inputAidDLines, inputAidSymbolicValues, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );
		
			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( inputAidOverviewPane.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// -D Lines
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.INPUT_AID_D,
			} );
			cpDefinition.addChild( inputAidDLines.getDetailDLines( data, type, project, streamId, compentId, fileItemId  ) );
			tc.addChild( cpDefinition );
			
			// Symbolic values
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.INPUT_AID_SYMBOLIC_VALUES,
			} );
			cpDefinition.addChild( inputAidSymbolicValues.getSymbolicValues( data, type, project, streamId, compentId, fileItemId  ) );
			tc.addChild( cpDefinition );	
			
			// -G Lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			cpGLines.addChild( gLinesPane.getGLines( data, type,  true, false, false, false, streamId, project ) );
			tc.addChild( cpGLines );
									
			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );