/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",	
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( ContentPane, PTEditor, PacbaseEditor, typeDict ) {

	return {
		getOverviewKeywords : function ( keywords, type ) {
			var overviewKeywords;
			require( [
				"dojo/string"
			], function ( string ) {
				var typeString = typeDict[ type ] == undefined ? type : typeDict[ type ];
				overviewKeywords = new ContentPane( {
					content : "<hr><strong>" + PTEditor.KEYWORD_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><P>" + string.substitute( PTEditor.KEYWORD_SECTION_DESCRIPTION, [
						typeString
					] ) + "</p>",
				} );
			} );
			if ( keywords.length != 0 ) {
				require( [
					"dojo/dom-construct"
				], function ( domConstruct ) {
					var keywordNames = "<ul>";
					keywords.forEach( function ( keyword ) {
						keywordNames += "<li>" + keyword.name + "</li>";
					} );
					keywordNames += "</ul>";
					domConstruct.place( keywordNames, overviewKeywords.containerNode );
				} );
			}
			return overviewKeywords;
		},

		getDetailKeywords : function ( data, type ) {
			var keywords = data.keywords;
			var detailKeywords;
			require( [
				"dojo/string"
			], function ( string ) {
				var typeString = typeDict[ type ] == undefined ? type : typeDict[ type ];
				detailKeywords = new ContentPane( {
					content : "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
				            + "<strong>" + PTEditor.KEYWORD_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
							+ string.substitute( PTEditor.KEYWORD_TABLE_SECTION_DESCRIPTION, [
								typeString
							] ) + "</p>",
				} );
			} );
			if ( keywords.length != 0 ) {
				require( [
					"dojo/dom-construct"
				], function ( domConstruct ) {
					var keywordNames = "<ul>";
					keywords.forEach( function ( keyword ) {
						keywordNames += "<li>" + keyword.name + "</li>";
					} );
					keywordNames += "</ul>";
					domConstruct.place( keywordNames, detailKeywords.containerNode );
				} );
			}
			return detailKeywords;
		}
	};
} );