/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/ContentPane", "dojox/layout/TableContainer", "dijit/form/TextBox",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function (ContentPane, TableContainer, TextBox, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function baseDefinition (data) {
		var definitionTable = new TableContainer( {
			labelWidth : rppDefaultLabelWidth
		} );

		var cobolType = new TextBox( {
			label : PacbaseEditor.PROGRAM_VARIANTE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.cobolType),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( cobolType );
		
		var generatedLanguage = new TextBox( {
			label : PacbaseEditor.LIBRARY_GENERATED_LANGUAGE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.generatedLanguage),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( generatedLanguage );
		
		var mapType = new TextBox( {
			label : PacbaseEditor.LIBRARY_MAP_TYPE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.mapType),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( mapType );
		
		var alphanumericDelimiter = new TextBox( {
			label : PacbaseEditor.LIBRARY_ALPHANUMERIC_DELIMITER,
			value : data.alphanumericDelimiter,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( alphanumericDelimiter );
		
		var decimalPointDelimiter = new TextBox( {
			label : PacbaseEditor.LIBRARY_DECIMAL_POINT_DELIMITER,
			value : data.decimalPointDelimiter,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( decimalPointDelimiter );
		
		var centurySystemDate = new TextBox( {
			label : PacbaseEditor.LIBRARY_CENTURY_SYSTEM_DATE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.centurySystemDate),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( centurySystemDate );
		
		var centuryReferenceYear = new TextBox( {
			label : PacbaseEditor.LIBRARY_CENTURY_REFERENCE_YEAR,
			value : data.centuryReferenceYear,
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( centuryReferenceYear );
		
		var generatedDateFormat = new TextBox( {
			label : PacbaseEditor.LIBRARY_GENERATED_DATE_FORMAT,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.generatedDateFormat),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( generatedDateFormat );
		
		var skeletonLanguage = new TextBox( {
			label : PacbaseEditor.LIBRARY_SKELETON_LANGUAGE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.skeletonLanguage),
			disabled : true,
			style : {
				"width" : rppDefaultTextWidth
			}
		} );
		definitionTable.addChild( skeletonLanguage );
		
		return definitionTable;
	}

	return {
		getDetailDefinition : function ( data, type, project, streamId, compentId, fileItemId ) {
			var detailDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content :  "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
				    + "<strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
							+ string.substitute( PacbaseEditor.SEGMENT_EDIT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			
			detailDefinition.addChild( baseDefinition(data) );

			return detailDefinition;
		}
	};
} );