/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  "./macroOverview", "./keywordsPane", "./macroComments", "./macroSource",  "./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, macroOverview, keywordsPane, macroComments, macroSource, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );

			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( macroOverview.getOverview( data, type, project ) );
			tc.addChild( cpOverview );
			
			// Comments
			var cpComments = new ContentPane( {
				title : PacbaseEditor.MACRO_COMMENTS_LINES,
			} );
			cpComments.addChild( macroComments.getDetailCommentLines( data, type ) );
			tc.addChild( cpComments );
			
			// -G Lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			cpGLines.addChild( gLinesPane.getGLines( data, type,  true, true, false, false, streamId, project ) );
			tc.addChild( cpGLines );
			
			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );
			
			// Source
			var cpSource = new ContentPane( {
				title : PacbaseEditor.MACRO_SOURCE,
			} );
			cpSource.addChild( macroSource.getDetailSource ( data, type, project, streamId, compentId, fileItemId  ) );
			tc.addChild( cpSource );
			
			return tc;
		}
	};
} );