/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  
		"./metaDataAggregateOverviewPane", /*The default overviews */ 
		"./keywordsPane", /* The keywords pane */
		"./metaComposition",
		"./metaDocumentation",		
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, metaDataAggregateOverviewPane, keywordsPane, metaComposition, metaDocumentation, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );
		
			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( metaDataAggregateOverviewPane.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// Composition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.META_COMPOSITION,
			} );
			if (data.dataDescription != undefined && data.dataDescription != "") {
				cpDefinition.addChild( metaComposition.getComposition( data, type, project, streamId, compentId, fileItemId  ) );
				tc.addChild( cpDefinition );
			}
			
			// Documentation
			var cpDocumentation = new ContentPane( {
				title : PacbaseEditor.META_DOCUMENTATION,
			} );
			cpDocumentation.addChild( metaDocumentation.getDocumentation( data, type, project, streamId, compentId, fileItemId  ) );
			tc.addChild( cpDocumentation );		
						
			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );