/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojo/string", "dijit/layout/ContentPane", "dojox/layout/TableContainer", "dijit/form/TextBox",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function (string, ContentPane, TableContainer, TextBox, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function metaDocumentation(data) {
		var content = "";
		if (  data.userDocumentation != undefined && data.userDocumentation.text != undefined ) {
			content = '<html><body>'+data.userDocumentation.text.replace(/\r/g,"<br>").replace(/\n/g,"");
		}
		var documentation = new ContentPane( {
			style : {
				"height": "auto",
				"max-height": ( rppCurrentPaneGridHeight ) + "px"
			},
			content: content,
		} );
	    return documentation;
	}

	return {
		getDocumentation : function ( data, type, project, streamId, compentId, fileItemId ) {			
			var cpDocumentation = new ContentPane( {
				content : "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
			    + "<strong>" + PacbaseEditor.DOCUMENTATION_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
						+ string.substitute( PacbaseEditor.DOCUMENTATION_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>"
						+ PacbaseEditor.DOCUMENTATION_USER
						+ "</p>",
						style : {
							'overflow' : 'auto',
						},
			} );
			
			cpDocumentation.addChild( metaDocumentation(data) );

			return cpDocumentation;
		}
	};
} );