/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/Textarea", "dijit/form/CheckBox",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, Textarea, CheckBox, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function baseDefinition (data) {
				
		var definitionTable = new TableContainer( {
			labelWidth : 200,
		} );
		
		var nature = new TextBox( {
			label : PacbaseEditor.REPORT_NATURE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.reportNature),
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( nature );
		
		var type = new TextBox( {
			label : PacbaseEditor.REPORT_TYPE,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.reportType),
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( type );
		
		var labelLength = new TextBox( {
			label : PacbaseEditor.REPORT_LABEL_LENGTH,
			value : data.labelLength,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( labelLength );
		
		var integerPartLength = new TextBox( {
			label : PacbaseEditor.REPORT_INTEGER_PART_LENGTH,
			value : data.integerPartLength,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( integerPartLength );
		
		var decimalPartLength = new TextBox( {
			label : PacbaseEditor.REPORT_DECIMAL_PART_LENGTH,
			value : data.decimalPartLength,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( decimalPartLength );
		
		var reportComment = new TextBox( {
			label : PacbaseEditor.REPORT_COMMENT,
			value : data.reportComment,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( reportComment );
		
		var lineLength = new TextBox( {
			label : PacbaseEditor.REPORT_LINE_LENGTH,
			value : data.lineLength,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( lineLength );
		
		var linesPerPage = new TextBox( {
			label : PacbaseEditor.REPORT_LINES_PER_PAGE,
			value : data.linesPerPage,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( linesPerPage );
				
	    var tableSize = new TextBox( {
			label : PacbaseEditor.REPORT_TABLE_SIZE,
			value : data.tableSize,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( tableSize );
	    
	    var writeOption = new TextBox( {
			label : PacbaseEditor.REPORT_WRITE_OPTION,
			value : rppEnumVDislayValue(PacEnumerationLabel, data.writeOption),
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( writeOption );
		
		var sectionPriority = new TextBox( {
			label : PacbaseEditor.REPORT_SECTION_PRIORITY,
			value : data.sectionPriority,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( sectionPriority );
		
		var editionComment = new TextBox( {
			label : PacbaseEditor.REPORT_EDITION_COMMENT,
			value : data.editionComment,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( editionComment );
				
		var editionCondition = new Textarea( {
			label : PacbaseEditor.REPORT_EDITION_CONDITION,
			value : data.editionCondition,
			style : {
				"width" : "300px"
			},
			disabled : true
		} );
		definitionTable.addChild( editionCondition );
	    
		return definitionTable;
	}

	return {
		getDetailDefinition : function ( data, type, project, streamId, compentId, fileItemId  ) {
			var detailDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content :  "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
				    + "<strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
							+ string.substitute( PacbaseEditor.SEGMENT_EDIT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			detailDefinition.addChild( baseDefinition(data) );

			return detailDefinition;
		}
	};
} );