/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojo/string", "dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/tree/ForestStoreModel",
		"dojo/data/ItemFileReadStore", "dojo/data/ItemFileWriteStore", "dojox/grid/DataGrid", "dijit/form/Button", "dijit/Dialog", "dijit/Tooltip", "./gLinesPane", 
		"dijit/TooltipDialog", "dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( string, TableContainer, ContentPane, TextBox, ForestStoreModel, ItemFileReadStore, ItemFileWriteStore, DataGrid, Button, Dialog, Tooltip, gLinesPane, TooltipDialog,
				PacbaseEditor, typeDict ) {	
	
	
	return {
		
		getDetailLLines : function ( data, type, project, streamId ) {	
			var LLines = data.LLines			
			var detailLLines = new ContentPane( {
				content :  "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
			    + "<strong>" + PacbaseEditor.REPORT_LLINE_TABTEXT + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
						+ string.substitute( PacbaseEditor.REPORT_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>",
						style : {
							'overflow' : 'auto',
						},
			} );
			
			// prepare layoutLLines
			var layoutLLines = [
 					{
						name : PacbaseEditor.REPORT_COLUMN_LABEL_ID,
						width : "70px",
						field : "_item",
						formatter : function ( item  ) {
							return getLabelID(item);
						}
					}, {
						name : PacbaseEditor.REPORT_COLUMN_JUMP,
						width : "50px",
						field : "_item",
						formatter : function ( item ) {
							return getJumpType(item);
						}
					},
						{
						name : PacbaseEditor.REPORT_COLUMN_LABEL,
						width : "1000px",
						field : "_item",
						formatter : function ( item ) {
							return getLabel(item);
						}
					},
					
			];
			
												
			// prepare lazy tree grid
			var data = {
				items : LLines
			};
			var store = new ItemFileReadStore( {
				data : data
			} );
			
			var hearderTooltips =  [PacbaseEditor.REPORT_TOOL_TIP_COLUMN_LABEL_ID ,
					                PacbaseEditor.REPORT_TOOL_TIP_COLUMN_JUMP,
					                PacbaseEditor.REPORT_TOOL_TIP_COLUMN_LABEL,];
			
			// create a new grid
			var LLinesGrid = new DataGrid( {
				store : store,
				structure : layoutLLines,
				height : ( rppCurrentPaneGridHeight - 70 ) + "px",
				autoWidth : true,	
				onStyleRow: function (row) {
					row.customClasses = "rppGridFixedDefaultFont";
				},
				canSort : function () {
					return false;
				},
				
				onHeaderCellMouseOver  : function (e) {
					dijit.showTooltip(hearderTooltips[e.cellIndex], e.cellNode);
				},
				onHeaderCellMouseOut : function (e) {
					dijit.hideTooltip(e.cellNode);
				} 	
				
				
			} );
			
			
			
			detailLLines.addChild(LLinesGrid);
			return detailLLines;
		
		}
	}
	function getLabelID( item ) {	
		if(item.labelID != undefined && item.labelID != "0") 
			return item.labelID;
		return "";
	}
	
	function getJumpType( item ) {	
		if(item.jumpType != undefined ){
			//item is PacLabelJumpTypeValues
			var res = item.jumpType[0].value;
			return getValueS(res);
		}
		return "";
	}
		
	function getLabel( item  ) {	
		if(item.label != undefined && item.label != "") {
			return item.label[0].replace(/ /g,"&nbsp;");
		}
		return "";
	}
	function getValue ( value ) {		
		return value.toString().replace("_","").replace("None","");
	}
	
	function getValueS ( value ) {		
		return value.toString().replace("_","").replace("STAR","*").replace("None","");
	}	
	} );