/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  
		"./reportOverviewPane", /*The default overviews */
		"./reportDefinition",
		"./reportLLine",
		"./reportDLine",
		"./reportCELine",
		"./keywordsPane", /* The keywords pane */
		"./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, reportOverviewPane, reportDefinition, reportLLine, reportDLine, reportCELine, keywordsPane, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );
		
			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( reportOverviewPane.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// Definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.REPORT_SECTION_HEADER,
			} );
			cpDefinition.addChild(reportDefinition.getDetailDefinition( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpDefinition );
			
			// CELine
			var ceLine = new ContentPane( {
				title : PacbaseEditor.REPORT_CELINE_TABTEXT,
			} );
			ceLine.addChild(reportCELine.getDetailCELines( data, type, project, streamId) );
			tc.addChild( ceLine );
			
			// LLine
			var lLine = new ContentPane( {
				title : PacbaseEditor.REPORT_LLINE_TABTEXT,
			} );
			lLine.addChild(reportLLine.getDetailLLines( data, type, project, streamId) );
			tc.addChild( lLine );
			
			// DLine
			var dLine = new ContentPane( {
				title : PacbaseEditor.REPORT_DLINE_TABTEXT,
			} );
			dLine.addChild(reportDLine.getDetailDLines( data, type, project, streamId) );
			tc.addChild( dLine );
			
			// -G Lines
			var gGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			gGLines.addChild( gLinesPane.getGLines( data, type,  true, false, false, false, streamId, project ) );
			tc.addChild( gGLines );		
			
			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );