/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane",  "./screenOverview", "./screenDefinition", "./screenCELines", "./screenCSLines", "./cpLinesPane", "./keywordsPane", "./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, screenOverview, screenDefinition, CELines, CSLines, cpLinesPane, keywordsPane, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );
		
			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( screenOverview.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );
			
			// Definition
			var cpDefinition = new ContentPane( {
				title : PacbaseEditor.PROGRAM_SECTION_HEADER,
			} );
			cpDefinition.addChild( screenDefinition.getDetailDefinition( data, type, streamId, project ) );
			tc.addChild( cpDefinition );	
			
			// CE Lines
			var cpCELines = new ContentPane( {
				title : PacbaseEditor.CELINE_SECTION_HEADER,
			} );
			cpCELines.addChild( CELines.getDetailCELines( data, type, streamId, project ) );
			tc.addChild( cpCELines );
			
			// CS Lines
			var cpCSLines = new ContentPane( {
				title : PacbaseEditor.CSLINE_SECTION_HEADER,
			} );
			cpCSLines.addChild( CSLines.getDetailCSLines( data, type, project, streamId ) );
			tc.addChild( cpCSLines );
			
			// CP Lines
			var cpCPLines = new ContentPane( {
				title : PacbaseEditor.CPLINE_TABTEXT,
			} );
			cpCPLines.addChild( cpLinesPane.getCPLines( data, type, streamId, project ) );
			tc.addChild( cpCPLines );
			
			// -G Lines
			var cpGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			cpGLines.addChild( gLinesPane.getGLines( data, type,  true, true, true, true, streamId, project ) );
			tc.addChild( cpGLines );
			
			// Keywords			
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );