/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojo/string", "dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/registry", "dijit/form/CheckBox",
		"dijit/tree/ForestStoreModel", "dojo/data/ItemFileWriteStore", "dojox/grid/LazyTreeGrid", "dijit/layout/BorderContainer",	
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( string, TableContainer, ContentPane, TextBox, registry, CheckBox, ForestStoreModel, ItemFileWriteStore, LazyTreeGrid, BorderContainer,
		PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function getExtensionPacbase ( extensions, className ) {
		if ( extensions.length == 0 ) {
			return "";
		} else {
			var extension = extensions.filter( function ( item ) {
				return className != undefined
						? item.facet == "pacbase" && item[ "class" ] == className : item.facet == "pacbase"
			} );
			return extension.length > 0
					? extension[ 0 ] : "";
		}
	}

	function getName ( item, streamId, project ) {
		if ( item[ "class" ] == "Filler" ) {
			return item[ "class" ];
		} else if ( item.dataDescription[ 0 ][ "class" ] == "DataUnionDescription" ) {
			return PacbaseEditor.REDEFINES;
		} else if ( item.dataDescription[ 0 ][ "class" ] == "DataElementDescription" ) {
			return "<span class='display_icon pacDataElementDescription'></span> " + item.dataDescription[ 0 ].name
		}
		if ( item.dataDefinition == "" )
			return item.dataDescription[ 0 ].name;
		var radicalElement = item.dataDefinition[0];
		return new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget("", radicalElement, false, streamId, project); 

	}

	function getDBE ( dbeLine ) {
		var cpDBE = new ContentPane( {
			content : "<strong>" + PacbaseEditor.CELINE_SQL_COMPLEMENT_EDIT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
					+ PacbaseEditor.CELINE_SQL_COMPLEMENT_EDIT_SECTION_DESCRIPTION + "</p>",
		} );
		var tableDBE = new TableContainer( {
			labelWidth : 150,
			valueWidth : 200,
		} );
		var textOriginalTable = new TextBox( {
			label : PacbaseEditor.CELINE_SQL_COMPLEMENT_ID,
			value : dbeLine.segment == ""
					? "" : dbeLine.segment[ 0 ].name + " " + typeDict[ dbeLine.segment[ 0 ][ "class" ] ],
			disabled : true
		} );
		var textColumnName = new TextBox( {
			label : PacbaseEditor.CELINE_SQL_COMPLEMENT_COLUMN,
			value : dbeLine.dataElement == ""
					? "" : dbeLine.dataElement[ 0 ].name + " " + dbeLine.dataElement[ 0 ].internalFormat,
			disabled : true
		} );
		tableDBE.addChild( textOriginalTable );
		tableDBE.addChild( textColumnName );
		cpDBE.addChild( tableDBE );
		return cpDBE;
	}

	function getSE ( seLine ) {
		var cpSE = new ContentPane( {
			content : "<strong>" + PacbaseEditor.CELINE_SOCRATE_COMPLEMENT_EDIT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
					+ PacbaseEditor.CELINE_SOCRATE_COMPLEMENT_EDIT_SECTION_DESCRIPTION + "</p>",
		} )
		var tableSE = new TableContainer( {
			labelWidth : 150,
		} );
		var textCharacteristic = new TextBox( {
			label : PacbaseEditor.CELINE_SOCRATE_CHARACTERISTIC,
			style : {
				width : "300px"
			},
			value : PacEnumerationLabel[ seLine.characteristicType[ 0 ][ "class" ] + seLine.characteristicType[ 0 ][ "value" ] ],
			disabled : true
		} );
		tableSE.addChild( textCharacteristic );

		var tableChain = new TableContainer( {
			label : PacbaseEditor.CELINE_SOCRATE_CHAIN,
		} );
		var checkBoxChain = new CheckBox( {
			label : PacbaseEditor.CELINE_SOCRATE_DOUBLE,
			checked : seLine.chain == "true",
			disabled : true
		} );
		tableChain.addChild( checkBoxChain );
		tableSE.addChild( tableChain );

		var tableAuthorization = new TableContainer( {
			title : PacbaseEditor.CELINE_SOCRATE_AUTHORIZATION,
			style : {
				"border-left" : "1px solid gray"
			},
		} );

		for ( var i = 0; i <= 9; i++ ) {
			var textSubschema = new TextBox( {
				label : string.substitute( PacbaseEditor.CELINE_SOCRATE_SUB_SCHEMA, [
					i
				] ),
				style : {
					width : "300px"
				},
				value : PacEnumerationLabel[ seLine[ "sub" + i + "SchemaAuthorization" ][ 0 ][ "class" ]
						+ seLine[ "sub" + i + "SchemaAuthorization" ][ 0 ][ "value" ][ 0 ].toUpperCase() ],
				disabled : true
			} );
			tableAuthorization.addChild( textSubschema );
		}

		tableSE.addChild( tableAuthorization );

		var textSOCRATE = new TextBox( {
			label : PacbaseEditor.CELINE_SOCRATE_ENTITY,
			style : {
				width : "300px"
			},
			value : seLine.referencedCharacteristic,
			disabled : true
		} );
		tableSE.addChild( textSOCRATE );

		cpSE.addChild( tableSE );

		return cpSE;
	}
	return {
		getOverviewSQLComplement : function () {
			var cpOverviewSQLComplement = new ContentPane( {
				content : "<hr><strong>" + PacbaseEditor.CELINE_SQL_COMPLEMENT_EDIT_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><P>"
						+ PacbaseEditor.CELINE_SQL_COMPLEMENT_EDIT_SECTION_DESCRIPTION + "</p>",
			} );
			return cpOverviewSQLComplement;
		},
		getSQLComplement : function ( components, type, project, streamId, fileItemId, label, name  ) {
		    var bc = new BorderContainer({
		        style: "height: 90%; width: 100%;",
		        gutters:true
		    });
		    
			var cpSQLComplement = new ContentPane( {
				content : "<strong>" + typeDict[ type ] + " " + name + " : " + label + "</strong><P>"
			    + "<strong>" + PacbaseEditor.CELINE_TABLE_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
						+ string.substitute( PacbaseEditor.CELINE_TABLE_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>",
						style : {
							'overflow' : 'auto',
							'width': '45%',
						},
						region: "left",
						splitter:true
			} );
			// prepare lazy tree grid
			var layoutSQL = [
					{
						name : PacbaseEditor.SEGMENT_CELINE_COLUMN_NAME,
						width : "150px",
						field : "_item",
						formatter : function ( item ) {
							var itemClass = item[ "class" ];
							if ( itemClass == "PacSQLDataBaseElement" )
								return "<span class='display_icon PacSQLDataBaseElement'></span> (-DBE)";
							else if ( itemClass == "PacSocrateElement" )
								return "<span class='display_icon PacSocrateElement'></span> (-SE)";
							else
								return getName( item, streamId, project );
						},
					}, {
						name : PacbaseEditor.CELINE_SQL_COMPLEMENT_TYPE,
						field : "_item",
						formatter : function ( item ) {
							var itemClass = item[ "class" ];
							return itemClass != undefined
									? ( itemClass == "PacSocrateElement"
											? item.characteristicType[ 0 ][ "value" ] : "" ) : "";
						}
					}, {
						name : PacbaseEditor.CELINE_SQL_COMPLEMENT_UPDATE,
						field : "_item",
						width : "150px",
						formatter : function ( item ) {
							var itemClass = item[ "class" ];
							if ( itemClass != undefined && itemClass == "PacSQLDataBaseElement" ) {
								var segmentName = item.segment[ 0 ][ "name" ];
								var dataElement = item.dataElement[ 0 ][ "name" ];
								return ( segmentName != undefined
										? segmentName : "" ) + ( dataElement != undefined
										? dataElement : "" );
							} else
								return "";
						}
					}
			];
			var data = {
				items : components
			};
			var store = new ItemFileWriteStore( {
				data : data,
			} );
			var model = new ForestStoreModel( {
				store : store,
				mayHaveChildren : function ( item ) {
					if ( item[ "class" ] == "PacSQLDataBaseElement" || item[ "class" ] == "PacSocrateElement" ) {
						return false;
					}
					var extensionPacDataCall = getExtensionPacbase( item.extensions, "PacDataCall" );
					if ( extensionPacDataCall != "" ) {
						if ( extensionPacDataCall.dbeLine != "" || extensionPacDataCall.seLine != "" )
							return true;
					}
					if ( item.dataDescription != undefined && item.dataDescription != "" ) {
						var dataDescription = item.dataDescription.filter( function ( object ) {
							return object.facet == "kernel";
						} )[ 0 ];
						if ( "redefines" in dataDescription ) {
							return dataDescription.redefines.length > 0
						}
						return dataDescription.components != undefined
								? dataDescription.components.length > 0 : false
					}
				},
				getChildren : function ( item, onComplete, onError ) {
					var extensionPacDataCall = getExtensionPacbase( item.extensions, "PacDataCall" );
					if ( extensionPacDataCall != "" ) {
						if ( extensionPacDataCall.seLine != "" )
							onComplete( extensionPacDataCall.seLine );
						if ( extensionPacDataCall.dbeLine != "" )
							onComplete( extensionPacDataCall.dbeLine );
					}
					var dataDescription = item.dataDescription.filter( function ( object ) {
						return object.facet == "kernel";
					} )[ 0 ];
					if ( dataDescription != undefined ) {
						if ( "redefines" in dataDescription )
							onComplete( dataDescription.redefines );
						else {
							if ( item.dataDescription[ 0 ].components != undefined )
								onComplete( item.dataDescription[ 0 ].components );
						}
					}
				},
			} );
			
			var hearderTooltips =  [PacbaseEditor.SEGMENT_CELINE_COLUMN_TOOL_TIP_NAME,
			                        PacbaseEditor.CELINE_SQL_COMPLEMENT_TYPE,
			                        PacbaseEditor.CELINE_SQL_COMPLEMENT_UPDATE,];
			
			var grid = new LazyTreeGrid( {
				treeModel : model,
				structure : layoutSQL,
				height : ( rppCurrentPaneGridHeight - 20 ) + "px",
				autoWidth : true, 
				selectable : true,
				canSort : function () {
					return false;
				},
				onHeaderCellMouseOver  : function (e) {
					dijit.showTooltip(hearderTooltips[e.cellIndex], e.cellNode);
				},
				onHeaderCellMouseOut : function (e) {
					dijit.hideTooltip(e.cellNode);
				}, 	
				onRowClick : function ( evt ) {
					var rowData = this.getItem( evt.rowIndex );
					var cpWidget = registry.byId( streamId + "#" + fileItemId + "SQLComplementDetail" );
					var childs = [];
					cpWidget.getChildren().forEach(function(child) {
						childs.push(child);
					});
					childs.forEach(function(child) {
						cpWidget.removeChild( child );
					});
					rowClass = rowData[ "class" ];
					if ( rowClass == "PacSQLDataBaseElement" || rowClass == "PacSocrateElement" ) {
						if ( rowClass == "PacSQLDataBaseElement" )
							cpWidget.addChild( getDBE( rowData ) );
						else if ( rowClass == "PacSocrateElement" )
							cpWidget.addChild( getSE( rowData ) );
					}
				},
			} );
			cpSQLComplement.addChild( grid );
			
			bc.addChild(cpSQLComplement);

			var SQLComplementDetail = new ContentPane( {
				region: "center",
				id :  streamId + "#" + fileItemId + "SQLComplementDetail"
			} );
			
			bc.addChild(SQLComplementDetail);

			return bc;
		}
	};
} );