/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane", "./segmentOverview", "./segmentDefinition", "./segmentCELines", "./segmentSQL", "./segmentSSLines",
		"./gLinesPane", "./keywordsPane", "./segmentLaL", "dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor"
], function ( TabContainer, ContentPane, segmentOverview, segmentDefinition, segmentCELines, segmentSQL, segmentSSLines, gLinesPane, keywordsPane, segmentLaL,
		PTEditor, PacbaseEditor ) {
	return {
		getSegmentTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );

			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			cpOverview.addChild( segmentOverview.getOverview( data, type, project ) );
			tc.addChild( cpOverview );
			
			var extensions = data.extensions.filter( function ( object ) {
				return object.facet === "pacbase";
			} );
			if ( extensions != undefined && extensions.length === 1 ) {
				var extension = extensions[ 0 ];
				var segmentType = extension.dataAggregateType["value"];
				
				// Definition
				var cpDefinition = new ContentPane( {
					title : PacbaseEditor.SEGMENT_EDIT_SECTION_TABTEXT,
				} );
				

				cpDefinition.addChild( segmentDefinition.getDetailDefinition( extension, data.label, data.name, type ) );
				tc.addChild( cpDefinition );

				// CE Lines
				var cpCELines = new ContentPane( {
					title : PacbaseEditor.CELINE_TABTEXT,
				} );
				cpCELines.addChild( segmentCELines.getDetailCELines( segmentType, data.dataDescription.components, data.label, data.name, type, project, streamId ) );
				tc.addChild( cpCELines );
				
				if ( "_None" == segmentType ) {
					// SQL Complements
					var cpSQLComplement = new ContentPane( {
						title : PacbaseEditor.DBDCOMPLEMENT_TABTEXT,
					} );
					// clone the data
					var components = JSON.parse( JSON.stringify( data.dataDescription.components ) );
					cpSQLComplement.addChild( segmentSQL.getSQLComplement( components, type, project, streamId,  fileItemId, data.label, data.name) );
					tc.addChild( cpSQLComplement );
				}
				
				if ( "_G" == segmentType && extension.ssLines != undefined ) {
					// SS lines
					var cpSSLines = new ContentPane( {
						title : PacbaseEditor.SSLINE_TABTEXT,
					} );
					cpSSLines.addChild( segmentSSLines.getDetailSSLines( extension.ssLines, type, data.label, data.name ) );
					tc.addChild( cpSSLines );
				}
				
				// Level, address and Length
				var cpLaL = new ContentPane( {
					title : PacbaseEditor.LEVEL_ADDRESS_LENGTH_TABTEXT,
				} );
				cpLaL.addChild( segmentLaL.getLaL( data, type, streamId, project, compentId, fileItemId ) );
				tc.addChild( cpLaL );

				// -G lines
				var cpGLines = new ContentPane( {
					title : PacbaseEditor.GLINE_TABTEXT,
				} );
				extensions = data.extensions.filter( function ( object ) {
					return object.facet === "pacbase" && object[ "class" ] == "PacDataAggregate";
				} );
				if ( extensions.length === 1 ) {
					cpGLines.addChild(  gLinesPane.getGLines( data, type, true, true, true, true, streamId, project ) );
				}
				tc.addChild( cpGLines );
			}			


			// Keywords
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );