/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017, 2018. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojo/string", "dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/tree/ForestStoreModel",
		"dojo/data/ItemFileReadStore", "dojox/grid/DataGrid", "dijit/form/Button", "dijit/Dialog", "dijit/Tooltip", "./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( string, TableContainer, ContentPane, TextBox, ForestStoreModel, ItemFileReadStore, DataGrid, Button, Dialog, Tooltip, gLinesPane, 
				PacbaseEditor, typeDict ) {	

	function getValue ( value ) {		
		return value.toString().replace("_","").replace("None","");
	}
		
	function getSegmentCode( item ) {
		if(item.segmentCode != undefined) {
			if (item[ "class" ] == "PacCSLineSegmentCall") {
				return "<span class='display_icon PacCSLineSegmentCall'></span> " + item.segmentCode;
			}
			if (item[ "class" ] == "PacCSLineDataElementCall") {
				return "<span class='display_icon PacCSLineDataElementCall'></span> " + item.segmentCode;
			}
			if (item[ "class" ] == "PacCSLineServerCall") {
				return "<span class='display_icon PacCSLineServerCall'></span> " + item.segmentCode;
			}
			if (item[ "class" ] == "PacCSLineLogicalViewCall") {
				return "<span class='display_icon PacCSLineLogicalViewCall'></span> " + item.segmentCode;
			}
			
			return item.segmentCode;	
		}
		return "";
	}
	
	
	function getLineNumber( item ) {	
		if(item.lineNumber != undefined) 
			return item.lineNumber;
		return "";
	}
	
	function getCategoryNature( item ) {	
		if (item.categoryNature != undefined && item.categoryNature != "") 
			return  getValue(item.categoryNature[0].value);
		return "";
	}
	
	function getGenerationLimit( item ) {	
		if (item.generationLimit != undefined) 
			return  getValue(item.generationLimit[0].value);
		return "";
	}
	
	function getReceptionUse( item ) {	
		if (item.clientUsageAndOrganization != undefined && item.clientUsageAndOrganization != "") {
			return  getValue(item.clientUsageAndOrganization[0].receptionUse[0].value);
		} else if (item.serverUsageAndOrganization != undefined && item.serverUsageAndOrganization != "") {
			return  getValue(item.serverUsageAndOrganization[0].receptionUse[0].value);
		} else if (item.receptionUse != "") {
			return getValue(item.receptionUse[0].value);
		}	
		return "";
	}
	
	function getDisplayUse( item ) {
		if (item.clientUsageAndOrganization != undefined && item.clientUsageAndOrganization != "") {
			return  getValue(item.clientUsageAndOrganization[0].displayUse[0].value);
		} else if (item.serverUsageAndOrganization != undefined && item.serverUsageAndOrganization != "") {
			return  getValue(item.serverUsageAndOrganization[0].displayUse[0].value);
		} else if (item.displayUse != "") {
			return getValue(item.displayUse[0].value);
		}	
		return "";
	}
	
	function getPreviousSegmentCode( item ) {	
		if(item.previousSegmentCode != undefined) 
			return item.previousSegmentCode;
		return "";
	}
	
	function getAccessKeySource( item ) {	
		if (item.accessKeySource != undefined) {
			var newValue = '';
			newValue += item.accessKeySource[0].replace(/ /g,"&nbsp;");			
			return getValue(newValue);			
		}
		return "";
	}	
	
	function getAccessKey( item , project, streamId) {
		if(item.dataElement != undefined && item.dataElement != "") {
			return new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget("", item.dataElement[0], false, streamId, project, "");
		}
		return item.accessKey;
	}
	
	function getControlBreak( item ) {	
		if (item.controlBreak != undefined) 
			return  getValue(item.controlBreak[0].value);
		return "";
	}
	
	function getOrganization( item ) {
		if (item.clientUsageAndOrganization != undefined && item.clientUsageAndOrganization != "") {
			return  getValue(item.clientUsageAndOrganization[0].organization[0].value);
		} else if (item.serverUsageAndOrganization != undefined && item.serverUsageAndOrganization != "") {
			return  getValue(item.serverUsageAndOrganization[0].organization[0].value);
		} else if (item.organization != "") {
			return getValue(item.organization[0].value);	
		} 
		return "";
	}
	
	function getDescriptionType( item ) {	
		if (item.descriptionType != undefined) 
			return  getValue(item.descriptionType[0].value);
		return "";
	}
	
	function getExternalName( item ) {	
		if(item.externalName != undefined) 
			return item.externalName;
		return "";
	}
	
	function getSegment( item , project, streamId) {
		if (item[ "class" ] == "PacCSLineLogicalViewCall") {
			if (item.logicalView != undefined) {
				return new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget("", item.logicalView[0], false, streamId, project, "");
			}
		}
		else {
			if (item.segment != undefined) {
				return new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget("", item.segment[0], false, streamId, project, "");
			}
		}
		return "";
	}
	
	function getSubSchema( item ) {	
		if (item.subSchema != undefined) 
			return  getValue(item.subSchema[0].value);
		return "";
	}
	
	function getGenerationLevel( item ) {	
		if(item.generateLevel != undefined) 
			return item.generateLevel.toString().replace("10","");
		return "";
	}
	
	function getDatabaseBlock( item , project, streamId) {	
		if(item.blockBase != undefined && item.blockBase != "") {
			return new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget("", item.blockBase[0], false, streamId, project, "");
		}
		return item.blockBase;
	}
	
	function getRecordType( item ) {	
		if (item.recordTypeValue != undefined) 
			return  getValue(item.recordTypeValue[0].value);
		return "";
	}
	
	function getServerName( item , project, streamId) {
		if(item.server != undefined && item.server != "") {
			return new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget("", item.server[0], false, streamId, project, "");
		}
		return "";
	}
	
	
	return {
		
		getDetailCSLines : function ( data, type, project, streamId ) 
		{	
			
			var cpDetailCSLines = new ContentPane( {
				content : "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
			    + "<strong>" + PacbaseEditor.CSLINE_SECTION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
						+ string.substitute( PacbaseEditor.CSLINE_TABLE_SECTION_DESCRIPTION, [
							typeDict[ type ]
						] ) + "</p>",
						style : {
							'overflow' : 'auto',
						},
			} );
			
			// prepare layoutCSLines
			var layoutCSLines = [
 					{
						name : PacbaseEditor.CSLINE_COLUMN_SEGMENT_NAME,
						width : "60px",
						field : "_item",
						formatter : function ( item , project, streamId ) {
						return getSegmentCode(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_LINENUMBER,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getLineNumber(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_CATEGORY,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getCategoryNature(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_GENERATION_LIMIT,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getGenerationLimit(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_RECEPTION_USE,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getReceptionUse(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_DISPLAY_USE,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getDisplayUse(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_PREVIOUS_SEGMENT_CODE,
						width : "60px",
						field : "_item",
						formatter : function ( item ) {
							return getPreviousSegmentCode(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_ACCESS_KEY_SOURCE,
						width : "120px",
						field : "_item",
						formatter : function ( item ) {
							return getAccessKeySource(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_ACCESS_KEY,
						width : "100px",
						field : "_item",
						formatter : function ( item ) {
							return getAccessKey(item, project, streamId);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_BREAK,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getControlBreak(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_ORGANIZATION,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getOrganization(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_DESCRIPTION_TYPE,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getDescriptionType(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_EXTERNAL_NAME,
						width : "100px",
						field : "_item",
						formatter : function ( item ) {
							return getExternalName(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_SEGMENT_CLIENT ,
						width : "100px",
						field : "_item",
						formatter : function ( item ) {
							return getSegment(item, project, streamId);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_SUBSCHEMA,
						width : "100px",
						field : "_item",
						formatter : function ( item ) {
							return getSubSchema(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_GENERATION_LEVEL,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getGenerationLevel(item);
							}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_DATABASE_BLOCK,
						width : "100px",
						field : "_item",
						formatter : function ( item ) {
							return getDatabaseBlock(item, project, streamId);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_RECORD_TYPE,
						width : "40px",
						field : "_item",
						formatter : function ( item ) {
							return getRecordType(item);
						}
					}, {
						name : PacbaseEditor.CSLINE_COLUMN_SERVER_NAME,
						width : "100px",
						field : "_item",
						formatter : function ( item ) {
							return getServerName(item, project, streamId);
						}					
					}, 
			];
			
													
			// prepare lazy tree grid
			var data = {
				items : data.CSLines
			};
			var store = new ItemFileReadStore( {
				data : data
			} );
			
			var hearderTooltips =  [PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_SEGMENT_NAME,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_LINENUMBER,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_CATEGORY,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_GENERATION_LIMIT,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_RECEPTION_USE,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_DISPLAY_USE,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_PREVIOUS_SEGMENT_CODE,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_ACCESS_KEY_SOURCE,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_ACCESS_KEY,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_BREAK,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_ORGANIZATION,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_DESCRIPTION_TYPE,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_EXTERNAL_NAME,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_SEGMENT_CLIENT,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_SUBSCHEMA,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_GENERATION_LEVEL,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_DATABASE_BLOCK,
					                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_RECORD_TYPE,
                                    PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_SERVER_NAME];
					/*if ("2" == screenMIA) {
						hearderTooltips.push(
								PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_SEGMENT_STANDARD
								)
					} else {
						hearderTooltips.push(
								PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_SEGMENT_CLIENT
								)
					};
					hearderTooltips.push(PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_SUBSCHEMA,
			                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_GENERATION_LEVEL,
			                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_DATABASE_BLOCK,
			                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_RECORD_TYPE,
			                PacbaseEditor.CSLINE_COLUMN_TOOL_TIP_SERVER_NAME
							);*/
			
			// create a new grid
			var CSLinesGrid = new DataGrid( {
				store : store,
				structure : layoutCSLines,
				height : ( rppCurrentPaneGridHeight - 70 ) + "px",
				autoWidth : true,
				onStyleRow: function (row) {
					row.customClasses = "rppGridFixedDefaultFont";
				},
				canSort : function () {
					return false;
				},
				onHeaderCellMouseOver  : function (e) {
					dijit.showTooltip(hearderTooltips[e.cellIndex], e.cellNode);
				},
				onHeaderCellMouseOut : function (e) {
					dijit.hideTooltip(e.cellNode);
				} 
			} );

			cpDetailCSLines.addChild(CSLinesGrid);
			return cpDetailCSLines;
		
		}
	}
} );