/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/CheckBox", "dijit/layout/BorderContainer",
		"com.ibm.teampdp.query.engine.web/ui/internal/page/jsModules/widgets/CommonDialogServerDefinition",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"		
], function ( TableContainer, ContentPane, TextBox, CheckBox, BorderContainer, CommonDialogServerDefinition, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function baseDefinition (data, project, streamId) {
		var commonDialogServerDefinition = 
			new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogServerDefinition("", data, streamId, project );
	    
		return commonDialogServerDefinition;
	}
	
	function serviceExternalName (data, project, streamId) {
		
		var definitionTable = new TableContainer( {
			style : {
				'overflow' : 'auto',
				'width': '60%',
			},
			region: "left",
			labelWidth : '48%',
		} );
		
		var externalName = new TextBox( {
			label : PacbaseEditor.SERVICE_EXTERNAL_NAME,			
			value : data.serverExternalName,
			disabled : true,
			style : {
				width : '98%',
			},
		} );
		definitionTable.addChild( externalName );
		
		return definitionTable;
	}

	return {
		getOverviewDefinition : function ( type ) {
			var overviewDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				overviewDefinition = new ContentPane( {
					content : "<hr><strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + ": </strong><P>"
							+ string.substitute( PacbaseEditor.SEGMENT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			overviewDefinition.addChild( baseDefinition(data) );
			return overviewDefinition;
		},
		getDetailDefinition : function ( data, type, project, streamId ) {
			var detailDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content :  "<strong>" + typeDict[ type ] +  " " + data.name + " : " + data.label + "</strong><P>"
				    + "<strong>" + PacbaseEditor.SEGMENT_SECTION_HEADER + ": </strong><hr><p>"
							+ string.substitute( PacbaseEditor.SEGMENT_EDIT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			detailDefinition.addChild( baseDefinition(data, project, streamId) );
			detailDefinition.addChild( serviceExternalName(data, project, streamId) );

			return detailDefinition;
		}
	};
} );