/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dojox/layout/TableContainer", "dijit/layout/ContentPane", "dijit/form/TextBox", "dijit/form/CheckBox",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacEnumerationLabel",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/typeDict"
], function ( TableContainer, ContentPane, TextBox, CheckBox, PacbaseEditor, PacEnumerationLabel, typeDict ) {
	function baseDefinition (data) {
		var definitionTable = new TableContainer( {
			labelWidth : 150,
		} );

		var textType = new TextBox( {
			label : PacbaseEditor.TEXT_TEXT_TYPE,
			value : data.textType,
			disabled : true
		} );
		definitionTable.addChild( textType );

		
		var sectionType = new TextBox( {
			label : PacbaseEditor.TEXT_SECTION_TYPE,
			value : data.sectionType,
			disabled : true
		} );
		definitionTable.addChild( sectionType );
	    
		return definitionTable;
	}

	return {
		getDetailDefinition : function ( data, type, project, streamId, compentId, fileItemId ) {
			var detailDefinition;
			require( [
				"dojo/string"
			], function ( string ) {
				detailDefinition = new ContentPane( {
					content :  "<strong>" + typeDict[ type ] + " " + data.name + " : " + data.label + "</strong><P>"
				    + "<strong>" + PacbaseEditor.TEXT_DEFINITION_HEADER + PacbaseEditor.SEPARATOR + "</strong><hr><P>"
							+ string.substitute( PacbaseEditor.SEGMENT_EDIT_SECTION_DESCRIPTION, [
								typeDict[ type ]
							] ) + "</p>",
				} );
			} );
			detailDefinition.addChild( baseDefinition(data) );

			return detailDefinition;
		}
	};
} );