/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
        "dojox/layout/TableContainer",         
        "dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
		"dijit/layout/ContentPane", 
		"./generalInfoPane", 
		"./generationParameterPane", 
		"./keywordsPane",
], function ( TableContainer, PacbaseEditor, ContentPane, generalInfoPane, generationParameterPane, keywordsPane ) {
	return {
		getOverview : function ( data, type, project, streamId, compentId, fileItemId ) {
			var overview = new ContentPane( {
				title : data.name,
				closable : true,
			} );
			
			// set the general information
			overview.addChild( generalInfoPane.getGeneralInfo( type, project, data.name, data.label ) );
			
			var metaInfo = new TableContainer( {
				labelWidth : 150,
				valueWidth : 200,
			} );
			var metaEntity = 
				new com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget(PacbaseEditor.PAC_META_ENTITY, data.metaEntity, true, streamId, project);	
			metaInfo.addChild( metaEntity );			
			overview.addChild(metaInfo);
			
			// set generation parameters
			if ( data.generationParameter != undefined )
				overview.addChild( generationParameterPane.getOverviewLibraryCall( data.generationParameter, type, project, streamId ) );

			// set the keywords
			overview.addChild( keywordsPane.getOverviewKeywords( data.keywords, type ) );

			return overview;
		}
	};
} );