/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane", "dojo/request/xhr", 
		"./userEntityOverviewPane", /*The default overviews */ 
		"./keywordsPane", /* The keywords pane */
		"./userEntityDescription",
		"./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, xhr, userEntityOverviewPane, keywordsPane, userEntityDescription, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );
		
			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );

			if (data.field != undefined && data.field != "") {
				// Get The Meta Entity
				xhr( net.jazz.ajax.contextRoot() + "/service/com.ibm.teampdp.query.engine.common.IRppDesignFileService", {
					method : "POST",
					// synchronous ensure that contentPane of content is well prepared.
					data : {
						streamId : streamId,
						fileItemId : data.metaEntity.fileItemId,
						compentId : data.metaEntity.componentID,
						project : project,
						type : "metaentity",
						name : data.metaEntity.name
					},
					sync: true,
					handleAs : "json"
				} ).then( function ( _data ) {
					cpOverview.addChild( userEntityOverviewPane.getOverview( data, type, project, streamId, compentId, fileItemId ) );
					tc.addChild( cpOverview );
					
					// Description
					var cpDefinition = new ContentPane( {
						title : PacbaseEditor.USER_ENTITY_DESCRIPTION,
					} );
					var metaEntity = _data;
					cpDefinition.addChild( userEntityDescription.getField( data, type, project, streamId, compentId, fileItemId, metaEntity  ) );
					tc.addChild( cpDefinition );
					
					// -G Lines
					var cpGLines = new ContentPane( {
						title : PacbaseEditor.GLINE_TABTEXT,
					} );
					// Check pacbase
					var extensions = data.extensions.filter( function ( object ) {
						return object.facet === "pacbase";
					} );
					if ( extensions.length === 1 ) {				
						cpGLines.addChild( gLinesPane.getGLines( data, type, true, false, false, false, streamId, project ) );				
						tc.addChild( cpGLines );
					}
								
					// Keywords					
					var cpKeywords = new ContentPane( {
						title : PTEditor.KEYWORD_SECTION_HEADER,
					} );
					cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
					tc.addChild( cpKeywords );
				}, function ( err ) {
					console.debug( err );
				} );

			}
			return tc;
		}
	};
} );