/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2018. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

define( [
		"dijit/layout/TabContainer", "dijit/layout/ContentPane", "./volumeOverview", "./volumeDLine", "./keywordsPane", "./gLinesPane",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PTEditor",
		"dojo/i18n!com.ibm.teampdp.query.engine.web/ui/internal/page/nls/PacbaseEditor",
], function ( TabContainer, ContentPane, volumeOverview, volumeDLine, keywordsPane, gLinesPane, PTEditor, PacbaseEditor ) {
	return {
		getTab : function ( data, type, project, streamId, compentId, fileItemId ) {
			var tc = new TabContainer( {
			} );

			// Overview
			var cpOverview = new ContentPane( {
				title : PTEditor.OVERVIEW_TABTEXT,
			} );
			
			cpOverview.addChild( volumeOverview.getOverview( data, type, project, streamId, compentId, fileItemId ) );
			tc.addChild( cpOverview );

			// DLines
			var dLines = new ContentPane( {
				title : PacbaseEditor.VOLUME_DLINE_TABTEXT,
			} );
			dLines.addChild(volumeDLine.getDetailDLines( data, type, project, streamId, compentId, fileItemId) );
			tc.addChild( dLines );
			
			// -G Lines
			var gGLines = new ContentPane( {
				title : PacbaseEditor.GLINE_TABTEXT,
			} );
			gGLines.addChild( gLinesPane.getGLines( data, type,  true, false, false, false, streamId, project ) );
			tc.addChild( gGLines );		

			// keywords
			var cpKeywords = new ContentPane( {
				title : PTEditor.KEYWORD_SECTION_HEADER,
			} );
			cpKeywords.addChild( keywordsPane.getDetailKeywords( data, type ) );
			tc.addChild( cpKeywords );

			return tc;
		}
	};
} );