/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017, 2018. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogCommunicationMonitorDefinition");


dojo.require( "dijit._Widget" );
dojo.require( "dijit._WidgetBase" );
dojo.require( "dijit._TemplatedMixin" );
dojo.require( "dijit._WidgetsInTemplateMixin" );

// Dojo Widgets in the template
dojo.require( "dijit.layout.TabContainer" );
dojo.require( "dijit.layout.ContentPane" );
dojo.require( "dijit.form.TextBox" );
dojo.require( "dijit.form.CheckBox" );
dojo.require( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget" );

dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );

define("com.ibm.teampdp.query.engine.web/ui/internal/page/jsModules/widgets/CommonDialogCommunicationMonitorDefinition", [],
function () {
	
	dojo.declare( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogCommunicationMonitorDefinition", [
		dijit._Widget, dijit._WidgetBase, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin], {
		
		templatePath : dojo.moduleUrl( "com.ibm.teampdp.query.engine.web", "ui/internal/page/jsModules/widgets/CommonDialogCommunicationMonitorDefinition.html" ),

		constructor : function (widgetLabel, data, streamId, project ) {
			this.label = widgetLabel;
			this.nlsPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
			this.nlsEnumPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );
			this.data = data;
			this.streamId = streamId;
			this.project = project;
		},

		postCreate : function () {
			
			var inheritedMessage = this.nlsPage.INHERITED;

			// link to CommunicationMonitorDialog or ServerDialog 
			if ( this.data[ "class" ] == "PacCommunicationMonitor" ) {
				if (this.data.pacDialogCommunicationMonitor != "") {
				this.communicationMonitorDialogRow.style.display = 'table-row';
				this.communicationMonitorDialogEntity.init("", this.data.pacDialogCommunicationMonitor, true, this.streamId, this.project);
				this.communicationMonitorDialogEntity.postCreate();
				} else if (this.data.pacDialogServer != "") {
					this.communicationMonitorDialogRow.style.display = 'table-row';
					this.communicationMonitorDialogEntity.init("", this.data.pacDialogServer, true, this.streamId, this.project);
					this.communicationMonitorDialogEntity.postCreate();					
				}
			}
			
			this.externalName.attr("value",this.data.externalName);
			
			// Inherit
			
			var messageSize = this.data.messageSize;
			if (this.data[ "class" ] != "PacDialogCommunicationMonitor" && this.data.pacDialogCommunicationMonitor != "") {
				var dialogMessageSize = this.data.pacDialogCommunicationMonitor.messageSize;
				if (messageSize == dialogMessageSize) {
					this.messageSize.attr("value",(dialogMessageSize + " ("+inheritedMessage+")"));
//					this.messageSize.attr("value",(this.data.pacDialogCommunicationMonitor.messageSize + " ("+inheritedMessage+")"));
				}
			}
			else
				this.messageSize.attr("value", messageSize);


			this.errorMessageSent.attr("value",rppCommunicationMonitorEnumVDisplayValue(this.data, this.nlsEnumPage, "errorMessageSent",inheritedMessage));
			this.communicationType.attr("value",rppCommunicationMonitorEnumVDisplayValue(this.data, this.nlsEnumPage, "communicationType",inheritedMessage));
			this.transactionCode.attr("value",this.data.transactionCode);

			this.cobolType.attr("value",rppCommunicationMonitorEnumVDisplayValue(this.data, this.nlsEnumPage, "cobolType",inheritedMessage));
			this.mapType.attr("value",rppCommunicationMonitorEnumVDisplayValue(this.data, this.nlsEnumPage, "mapType",inheritedMessage));

			var cobType = this.data.cobolType[ "value" ].toUpperCase() ;
			if ( cobType == "_NONE" )
				if (this.data.pacDialogCommunicationMonitor != "")
					cobType = this.data.pacDialogCommunicationMonitor.cobolType[ "value" ];
				else if (this.data.pacDialogServer != "") {
					cobType = this.data.pacDialogServer.cobolType[ "value" ];
				}
			var mapType = this.data.mapType[ "value" ].toUpperCase() ;
			if ( mapType == "_NONE" )
				if (this.data.pacDialogCommunicationMonitor != "")
					mapType = this.data.pacDialogCommunicationMonitor.mapType[ "value" ];
				else if (this.data.pacDialogServer != "")
					mapType = this.data.pacDialogServer.mapType[ "value" ];

			var cobAndMapType = cobType.replace("_","")+mapType.replace("_","");
			this.cobAndMapType.attr("value",this.nlsEnumPage[ "PacDialogGeneratedLanguageValues" + "_"+cobAndMapType]);

			var cobAndMapType = cobType.replace("_","")+mapType.replace("_","");
			this.cobAndMapType.attr("value",this.nlsEnumPage[ "PacDialogGeneratedLanguageValues" + "_"+cobAndMapType]);
			
		},
} );
});
