/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2018. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogDefinition");


dojo.require( "dijit._Widget" );
dojo.require( "dijit._WidgetBase" );
dojo.require( "dijit._TemplatedMixin" );
dojo.require( "dijit._WidgetsInTemplateMixin" );

// Dojo Widgets in the template
dojo.require( "dijit.layout.TabContainer" );
dojo.require( "dijit.layout.ContentPane" );
dojo.require( "dijit.form.TextBox" );
dojo.require( "dijit.form.CheckBox" );
dojo.require( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget" );

dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );

define("com.ibm.teampdp.query.engine.web/ui/internal/page/jsModules/widgets/CommonDialogDefinition", [],
function () {
	
	dojo.declare( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogDefinition", [
		dijit._Widget, dijit._WidgetBase, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin], {
		
		templatePath : dojo.moduleUrl( "com.ibm.teampdp.query.engine.web", "ui/internal/page/jsModules/widgets/CommonDialogDefinition.html" ),

		constructor : function (widgetLabel, data, streamId, project ) {
			this.label = widgetLabel;
			this.nlsPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
			this.nlsEnumPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );
			this.data = data;
			this.streamId = streamId;
			this.project = project;
		},

		postCreate : function () {
			
			var inheritedMessage = this.nlsPage.INHERITED;
			this.programExternalName.attr("value",this.data.programExternalName);
			if ( this.data[ "class" ] == "PacScreen" ) {
				this.screenDialogRow.style.display = 'table-row';
				this.screenDialogEntity.init("",this.data.dialog, true, this.streamId, this.project);
				this.screenDialogEntity.postCreate();
				this.screenExternalNameRow.style.display = 'table-row';
				this.generateWithMapRow.style.display = 'table-row';
				this.screenExternalName.attr("value", this.data.screenExternalName);
				this.generateWithMap.attr("checked", this.data.generateWithMap == "true");
				this.generateWithMap.attr("disabled", true);
				if ( this.data.generateWithMap == "true" )
					this.generateWithMap.domNode.firstChild.setAttribute('aria-label', this.nlsPage.SELECTED);
				else
					this.generateWithMap.domNode.firstChild.setAttribute('aria-label', this.nlsPage.NOT_SELECTED);
			}
			
			// Inherit
			
			if ( this.data.screenLineNumber == "0" && this.data[ "class" ] != "PacDialog" )
				this.screenLineNumber.attr("value",(this.data.dialog.screenLineNumber + " ("+inheritedMessage+")").trim());
			else
				this.screenLineNumber.attr("value",this.data.screenLineNumber);
			if ( this.data.screenColumnNumber == "0" && this.data[ "class" ] != "PacDialog" )
				this.screenColumnNumber.attr("value",(this.data.dialog.screenColumnNumber + " ("+inheritedMessage+")").trim());
			else
				this.screenColumnNumber.attr("value",this.data.screenColumnNumber);
			if ( this.data.tabs == "0" && this.data[ "class" ] != "PacDialog" )
				this.tabs.attr("value",(this.data.dialog.tabs + " ("+inheritedMessage+")").trim());
			else
				this.tabs.attr("value",this.data.tabs);
			if ( this.data.transactionCode == "" && this.data[ "class" ] != "PacDialog" )
				this.transactionCode.attr("value",(this.data.dialog.transactionCode + " ("+inheritedMessage+")").trim());
			else
				this.transactionCode.attr("value",this.data.transactionCode);
			if ( this.data.initialCharacter == "" && this.data[ "class" ] != "PacDialog" )
				this.initialCharacter.attr("value",(this.data.dialog.initialCharacter + " ("+inheritedMessage+")").trim());
			else
				this.initialCharacter.attr("value",this.data.initialCharacter);
			if ( this.data.helpCharacterElement == "" && this.data[ "class" ] != "PacDialog" )
				this.helpCharacterElement.attr("value",(this.data.dialog.helpCharacterElement + " ("+inheritedMessage+")").trim());
			else
				this.helpCharacterElement.attr("value",this.data.helpCharacterElement);
			if ( this.data.helpCharacterScreen == "" && this.data[ "class" ] != "PacDialog" )
				this.helpCharacterScreen.attr("value",(this.data.dialog.helpCharacterScreen + " ("+inheritedMessage+")").trim());
			else
				this.helpCharacterScreen.attr("value",this.data.helpCharacterScreen);
			
			this.dialogType.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "dialogType",inheritedMessage));
			this.cobolType.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "cobolType",inheritedMessage));
			this.labelPresentation.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "labelPresentation",inheritedMessage));
			this.mapType.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "mapType",inheritedMessage));
			var cobType = this.data.cobolType[ "value" ].toUpperCase() ;
			if ( cobType == "_NONE" )
				cobType = this.data.dialog.cobolType[ "value" ];
			var mapType = this.data.mapType[ "value" ].toUpperCase() ;
			if ( mapType == "_NONE" )
				mapType = this.data.dialog.mapType[ "value" ];			
			var cobAndMapType = cobType.replace("_","")+mapType.replace("_","");
			this.cobAndMapType.attr("value",this.nlsEnumPage[ "PacDialogGeneratedLanguageValues" + "_"+cobAndMapType]);
			
			this.inputColorAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "inputColorAtt",inheritedMessage));
			this.inputIntensityAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "inputIntensityAtt",inheritedMessage));
			this.inputPresentationAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "inputPresentationAtt",inheritedMessage));
			this.labelColorAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "labelColorAtt",inheritedMessage));
			this.labelIntensityAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "labelIntensityAtt",inheritedMessage));
			this.labelPresentationAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "labelPresentationAtt",inheritedMessage));
			this.displayColorAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "displayColorAtt",inheritedMessage));
			this.displayIntensityAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "displayIntensityAtt",inheritedMessage));
			this.displayPresentationAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "displayPresentationAtt",inheritedMessage));
			this.errMessColorAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "errMessColorAtt",inheritedMessage));
			this.errMessIntensityAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "errMessIntensityAtt",inheritedMessage));
			this.errMessPresentationAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "errMessPresentationAtt",inheritedMessage));	
			this.errFieldColorAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "errFieldColorAtt",inheritedMessage));
			this.errFieldIntensityAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "errFieldIntensityAtt",inheritedMessage));
			this.errFieldPresentationAtt.attr("value",rppScreenEnumVDislayValue(this.data, this.nlsEnumPage, "errFieldPresentationAtt",inheritedMessage));				
		},
} );
});
