/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2018. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogFolderDefinition");


dojo.require( "dijit._Widget" );
dojo.require( "dijit._WidgetBase" );
dojo.require( "dijit._TemplatedMixin" );
dojo.require( "dijit._WidgetsInTemplateMixin" );

// Dojo Widgets in the template
dojo.require( "dijit.layout.TabContainer" );
dojo.require( "dijit.layout.ContentPane" );
dojo.require( "dijit.form.TextBox" );
dojo.require( "dijit.form.CheckBox" );
dojo.require( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget" );

dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );

define("com.ibm.teampdp.query.engine.web/ui/internal/page/jsModules/widgets/CommonDialogFolderDefinition", [],
function () {
	
	dojo.declare( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogFolderDefinition", [
		dijit._Widget, dijit._WidgetBase, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin], {
		
		templatePath : dojo.moduleUrl( "com.ibm.teampdp.query.engine.web", "ui/internal/page/jsModules/widgets/CommonDialogFolderDefinition.html" ),

		constructor : function (widgetLabel, data, streamId, project ) {
			this.label = widgetLabel;
			this.nlsPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
			this.nlsEnumPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );
			this.data = data;
			this.streamId = streamId;
			this.project = project;
		},

		postCreate : function () {
			
			var inheritedMessage = this.nlsPage.INHERITED;

			// link to folderDialog
			if ( this.data[ "class" ] == "PacFolder" ) {
				this.folderDialogRow.style.display = 'table-row';
				this.folderDialogEntity.init("",this.data.pacDialogFolder, true, this.streamId, this.project);
				this.folderDialogEntity.postCreate();
			}
			
			this.externalName.attr("value",this.data.externalName);
			
			// Inherit
			
			this.lockOption.attr("value",rppFolderEnumVDisplayValue(this.data, this.nlsEnumPage, "lockOption",inheritedMessage));
			this.paginationMode.attr("value",rppFolderEnumVDisplayValue(this.data, this.nlsEnumPage, "paginationMode",inheritedMessage));

			this.cobolType.attr("value",rppFolderEnumVDisplayValue(this.data, this.nlsEnumPage, "cobolType",inheritedMessage));
			this.mapType.attr("value",rppFolderEnumVDisplayValue(this.data, this.nlsEnumPage, "mapType",inheritedMessage));

			var cobType = this.data.cobolType[ "value" ].toUpperCase() ;
			if ( cobType == "_NONE" )
				cobType = this.data.pacDialogFolder.cobolType[ "value" ];
			var mapType = this.data.mapType[ "value" ].toUpperCase() ;
			if ( mapType == "_NONE" )
				mapType = this.data.pacDialogFolder.mapType[ "value" ];			
			var cobAndMapType = cobType.replace("_","")+mapType.replace("_","");
			this.cobAndMapType.attr("value",this.nlsEnumPage[ "PacDialogGeneratedLanguageValues" + "_"+cobAndMapType]);

			// Error Server 
			if ( this.data.errorServer != ""  ) {
				this.errorServerRow.style.display = 'table-row';
				this.errorServer.init("",this.data.errorServer, true, this.streamId, this.project);
				this.errorServer.postCreate();			
			}
			else if (this.data[ "class" ] == "PacDialogFolder") {
				this.no_ErrorServerRow.style.display = 'table-row';
				}
				// Error Server inherited from folder dialog	
				else this.inherited_ErrorServerRow.style.display = 'table-row';								

			// Buffer: only for folderDialog
			if ( this.data[ "class" ] == "PacDialogFolder" ) {
				this.bufferBox.style.display = 'table-row';
				this.bufferSegmentRow.style.display = 'table-row';
				this.bufferSegment.init("",this.data.buffer, true, this.streamId, this.project);
				this.bufferSegment.postCreate();

				this.bufferCode.attr("value",this.data.buffer.name);
				this.bufferDescriptionType.attr("value",rppFolderEnumVDisplayValue(this.data, this.nlsEnumPage, "bufferDescriptionType",inheritedMessage));
				this.bufferExternalName.attr("value",this.data.bufferExternalName);
			}

		},
} );
});
