/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017, 2018. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogFolderViewDefinition");


dojo.require( "dijit._Widget" );
dojo.require( "dijit._WidgetBase" );
dojo.require( "dijit._TemplatedMixin" );
dojo.require( "dijit._WidgetsInTemplateMixin" );

// Dojo Widgets in the template
dojo.require( "dijit.layout.TabContainer" );
dojo.require( "dijit.layout.ContentPane" );
dojo.require( "dijit.form.TextBox" );
dojo.require( "dijit.form.CheckBox" );
dojo.require( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget" );

dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );

define("com.ibm.teampdp.query.engine.web/ui/internal/page/jsModules/widgets/CommonDialogFolderViewDefinition", [],
function () {
	
	dojo.declare( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogFolderViewDefinition", [
		dijit._Widget, dijit._WidgetBase, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin], {
		
		templatePath : dojo.moduleUrl( "com.ibm.teampdp.query.engine.web", "ui/internal/page/jsModules/widgets/CommonDialogFolderViewDefinition.html" ),

		constructor : function (widgetLabel, data, streamId, project ) {
			this.label = widgetLabel;
			this.nlsPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
			this.nlsEnumPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );
			this.data = data;
			this.streamId = streamId;
			this.project = project;
		},

		postCreate : function () {
			
			var inheritedMessage = this.nlsPage.INHERITED;

			// link to folderViewDialog
			if ( this.data[ "class" ] == "PacFolderView" ) {
				this.folderDialogViewRow.style.display = 'table-row';
				this.folderDialogViewEntity.init("",this.data.pacDialogFolderView, true, this.streamId, this.project);
				this.folderDialogViewEntity.postCreate();
			}
			
			this.prefixClass.attr("value",this.data.prefixClass);
			
			// Inherit
			
//			this.lockOption.attr("value",rppFolderEnumVDisplayValue(this.data, this.nlsEnumPage, "lockOption",inheritedMessage));
//			this.paginationMode.attr("value",rppFolderEnumVDisplayValue(this.data, this.nlsEnumPage, "paginationMode",inheritedMessage));
//
//			this.cobolType.attr("value",rppFolderEnumVDisplayValue(this.data, this.nlsEnumPage, "cobolType",inheritedMessage));
//			this.mapType.attr("value",rppFolderEnumVDisplayValue(this.data, this.nlsEnumPage, "mapType",inheritedMessage));
//
//			var cobType = this.data.cobolType[ "value" ].toUpperCase() ;
//			if ( cobType == "_NONE" )
//				cobType = this.data.pacDialogFolder.cobolType[ "value" ];
//			var mapType = this.data.mapType[ "value" ].toUpperCase() ;
//			if ( mapType == "_NONE" )
//				mapType = this.data.pacDialogFolder.mapType[ "value" ];			
//			var cobAndMapType = cobType.replace("_","")+mapType.replace("_","");
//			this.cobAndMapType.attr("value",this.nlsEnumPage[ "PacDialogGeneratedLanguageValues" + "_"+cobAndMapType]);

			// Folder 
			if ( this.data.folder != ""  ) {
				this.folderRow.style.display = 'table-row';
				this.folder.init("",this.data.folder, true, this.streamId, this.project);
				this.folder.postCreate();			
			}
			else if (this.data[ "class" ] == "PacDialogFolderView") {
				this.no_FolderRow.style.display = 'table-row';
				}
				// Folder inherited from dialog	
				else this.inherited_FolderRow.style.display = 'table-row';								

		},
} );
});
