/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2016, 2018. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogServerDefinition");


dojo.require( "dijit._Widget" );
dojo.require( "dijit._WidgetBase" );
dojo.require( "dijit._TemplatedMixin" );
dojo.require( "dijit._WidgetsInTemplateMixin" );

// Dojo Widgets in the template
dojo.require( "dijit.layout.TabContainer" );
dojo.require( "dijit.layout.ContentPane" );
dojo.require( "dijit.form.TextBox" );
dojo.require( "dijit.form.CheckBox" );
dojo.require( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RadicalEntityWidget" );

dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );

define("com.ibm.teampdp.query.engine.web/ui/internal/page/jsModules/widgets/CommonDialogServerDefinition", [],
function () {
	
	dojo.declare( "com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.CommonDialogServerDefinition", [
		dijit._Widget, dijit._WidgetBase, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin], {
		
		templatePath : dojo.moduleUrl( "com.ibm.teampdp.query.engine.web", "ui/internal/page/jsModules/widgets/CommonDialogServerDefinition.html" ),

		constructor : function (widgetLabel, data, streamId, project ) {
			this.label = widgetLabel;
			this.nlsPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacbaseEditor" );
			this.nlsEnumPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PacEnumerationLabel" );
			this.data = data;
			this.streamId = streamId;
			this.project = project;
		},

		postCreate : function () {
			
			var inheritedMessage = this.nlsPage.INHERITED;

			// link to serverDialog
			if ( this.data[ "class" ] == "PacServer" ) {
				this.serverDialogRow.style.display = 'table-row';
				this.serverDialogEntity.init("",this.data.dialog, true, this.streamId, this.project);
				this.serverDialogEntity.postCreate();
			}
			
			this.externalName.attr("value",this.data.programExternalName);
			
			// Inherit
			
			if ( this.data.transactionCode == "" && this.data[ "class" ] != "PacDialogServer" )
				this.transactionCode.attr("value",(this.data.dialog.transactionCode + " ("+inheritedMessage+")").trim());
			else
				this.transactionCode.attr("value",this.data.transactionCode);
			
			this.cobolType.attr("value",rppServerEnumVDisplayValue(this.data, this.nlsEnumPage, "cobolType",inheritedMessage));			
			this.mapType.attr("value",rppServerEnumVDisplayValue(this.data, this.nlsEnumPage, "mapType",inheritedMessage));
            
			var cobType = this.data.cobolType[ "value" ].toUpperCase() ;
			if ( cobType == "_NONE" )				
				cobType = this.data.dialog.cobolType[ "value" ];
			var mapType = this.data.mapType[ "value" ].toUpperCase() ;
			if ( mapType == "_NONE" )
				mapType = this.data.dialog.mapType[ "value" ];				
			var cobAndMapType = cobType.replace("_","")+mapType.replace("_","");
			this.cobAndMapType.attr("value",this.nlsEnumPage[ "PacDialogGeneratedLanguageValues" + "_"+cobAndMapType]);
			
		},
} );
});
