/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2017, 2018. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RPPTabController");

dojo.require('dijit.layout.TabController');
dojo.require( "dijit.registry" );
dojo.require( "dijit.MenuItem" );
dojo.requireLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PTEditor" );

dojo.declare('com.ibm.teampdp.query.engine.web.ui.internal.page.jsModules.widgets.RPPTabController', dijit.layout.TabController,
{
    constructor: function(args) {
        this.inherited(arguments);
        this.nlsPage = dojo.getLocalization( "com.ibm.teampdp.query.engine.web.ui.internal.page", "PTEditor" );
    },
    
    postCreate: function() {
        this.inherited(arguments);
        var closeMenu = dijit.registry.byId(this.id + "_Menu");
        var closeAll = new dijit.MenuItem({
			label: this.nlsPage.CLOSE_ALL,
			ownerDocument: this.ownerDocument,
			dir: this.dir,
			lang: this.lang,
			textDir: this.textDir,
			onClick: function(evt){
				var tc = dijit.registry.byId( "tabContainer" );
				var toClose = [];
				tc.getChildren().forEach( function ( item ) {
					if ( item.closable == true )
						toClose.push(item);
				});
				toClose.forEach( function ( item ) {
					tc.removeChild(item);
				});
				toClose.forEach( function ( item ) {
					item.destroy();
				});
			}
		})
		closeMenu.addChild(closeAll);		
    },
    
    
});
